#include <algorithm>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define INF 0x3f3f3f3f
#define INFLL (int64_t)(1e18)
#define EPS 1e-9

template <class T> istream &operator>>(istream &is, vector<T> &a) {
    for (size_t i = 0; i < a.size(); ++i)
        is >> a[i];
    return is;
}

vector<long long> tree, vv;

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = vv[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

void update(int v, int l, int r, int ind, long long x) {
    if (ind >= r || l > ind)
        return;
    if (l + 1 == r) {
        tree[v] += x;
        return;
    }
    int m = (l + r) / 2;
    update(2 * v + 1, l, m, ind, x);
    update(2 * v + 2, m, r, ind, x);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    int m;
    cin >> m;
    long long ans = 0;
    vv.resize(n, 0);
    for (int i = 1; i <= n; ++i)
        for (int j = i; j <= n; j += i)
            vv[i - 1] += a[j - 1];
    tree.resize(4 * n, -INFLL);
    build(0, 0, n);
    for (int i = 0; i < m; ++i) {
        int p;
        long long s;
        cin >> p >> s;
        for (int k = 1; k * p <= n; ++k)
            update(0, 0, n, k * p - 1, s);
        ans += tree[0];
        for (int k = 1; k * p <= n; ++k)
            update(0, 0, n, k * p - 1, -s);
    }
    cout << ans;
}
