#include <algorithm>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define INF 0x3f3f3f3f
#define INFLL (long long)(1e18)
#define EPS 1e-9

template <class T> istream &operator>>(istream &is, vector<T> &a) {
    for (size_t i = 0; i < a.size(); ++i)
        is >> a[i];
    return is;
}

vector<long long> tree, vv;

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = vv[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

void update(int v, int l, int r, int ind, long long x) {
    if (ind >= r || l > ind)
        return;
    if (l + 1 == r) {
        tree[v] += x;
        return;
    }
    int m = (l + r) / 2;
    update(2 * v + 1, l, m, ind, x);
    update(2 * v + 2, m, r, ind, x);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    int m;
    cin >> m;
    long long ans = 0;
    vv.resize(n, 0);
    for (int i = 1; i <= n; ++i)
        for (int j = i; j <= n; j += i)
            vv[i - 1] += a[j - 1];
    tree.resize(4 * n, -INFLL);
    //    build(0, 0, n);
    vector<bool> used(n, true);
    vector<pair<long long, int>> vvv;
    for (int i = 0; i < n; ++i)
        vvv.push_back({vv[i], i});
    sort(rall(vvv));
    vector<int> tmp(n);
    for (int i = 0; i < n; ++i)
        tmp[vvv[i].second] = i;
    for (int i = 0; i < m; ++i) {
        int p;
        long long s;
        cin >> p >> s;
        long long cur = -INFLL;
        if (s >= 0)
            cur = vvv[0].first;
        int d = 1;
        vector<int> dd;
        while (d * d <= p) {
            if (p % d == 0) {
                cur = max(cur, vv[d - 1] + s);
                used[tmp[d - 1]] = false;
                cur = max(cur, vv[p / d - 1] + s);
                used[tmp[p / d - 1]] = false;
                dd.push_back(d);
                dd.push_back(p / d);
            }
            ++d;
        }
        if (s < 0)
            for (int j = 0; j < n; ++j)
                if (used[j]) {
                    cur = max(cur, vvv[j].first);
                    break;
                }
        ans += cur;
        for (int j : dd)
            used[tmp[j - 1]] = true;
    }
    cout << ans;
}