#include <algorithm>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define INF 0x3f3f3f3f
#define INFLL (int64_t)(1e18)
#define EPS 1e-9

template <class T> istream &operator>>(istream &is, vector<T> &a) {
    for (size_t i = 0; i < a.size(); ++i)
        is >> a[i];
    return is;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> coords(n);
    pair<int, int> ma = {0, 0};
    for (int i = 0; i < n; ++i) {
        cin >> coords[i].first >> coords[i].second;
        ma.first = max(ma.first, coords[i].first);
        ma.second = max(ma.second, coords[i].second);
    }
    vector<vector<int>> tochkinapryamoi1(ma.second + 1),
        tochkinapryamoi2(ma.first + 1);
    for (int i = 0; i < n; ++i) {
        tochkinapryamoi1[coords[i].second].push_back(coords[i].first);
        tochkinapryamoi2[coords[i].first].push_back(coords[i].second);
    }
    for (int i = 0; i < n; ++i) {
        sort(all(tochkinapryamoi1[coords[i].second]));
        sort(all(tochkinapryamoi2[coords[i].first]));
    }
    int ans = 0;
#define FAST 1
#if FAST
    if (ma.first * ma.second * n <= 1e7) {
        for (int i = 1; i <= ma.first; ++i) {
            for (int j = 1; j <= ma.second; ++j) {
                int cur = 0;
                for (int k = 0; k < n; ++k)
                    if (coords[k].first >= i - w && coords[k].first <= i &&
                        coords[k].second >= j - h && coords[k].second <= j)
                        ++cur;
                ans = max(ans, cur);
            }
        }
    } else {
#endif
        for (int i = 0; i < n; ++i) {
            int cur = 0;
            for (int j = coords[i].second; j >= max(0, coords[i].second - h);
                 --j) {
                cur +=
                    upper_bound(all(tochkinapryamoi1[j]), coords[i].first) -
                    lower_bound(all(tochkinapryamoi1[j]), coords[i].first - w);
            }
            ans = max(ans, cur);
        }
#if FAST
    }
#endif
    cout << ans;
}
