#include<bits/stdc++.h>

using namespace std;

const int MX = 3e5;

vector<int> tree(4 * MX, 0);
vector<int> add(4 * MX, 0);

void push(int v, int l, int r) {
    tree[v] += add[v];
    if (l + 1 == r) {
        add[v] = 0;
        return;
    }
    add[v + v + 1] += add[v];
    add[v + v + 2] += add[v];
    add[v] = 0;
}

void update(int tl, int tr, int x, int v = 0, int l = 0, int r = MX) {
    push(v, l, r);
    if (tr <= l || r <= tl)
        return;
    if (tl <= l && r <= tr) {
        add[v] += x;
        push(v, l, r);
        return;
    }
    if (l + 1 == r)
        return;
    int m = (l + r) / 2;
    update(tl, tr, x, v + v + 1, l, m);
    update(tl, tr, x, v + v + 2, m, r);
    tree[v] = max(tree[v + v + 1], tree[v + v + 2]);
}

bool cmp(pair<int, int> a, pair<int, int> b) {
    if (a.first != b.first)
        return a.first < b.first;
    return a.second > b.second;
}

int main() {
    int n, w, h;
    cin >> n >> w >> h;
    if (n <= 1000) {
        vector<pair<int, int> > a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i].first >> a[i].second;
        }
        sort(a.begin(), a.end(), cmp);
        int mx = 0;
        multiset<int> all;
        int p1 = 0;
        for (int i = 0; i < n; ++i) {
            all.insert(a[i].second);
            while (p1 < i && a[p1].first + w < a[i].first)
                all.erase(all.find(a[p1++].second));
            vector<int> now;
            for (auto u : all)
                now.push_back(u);
            for (int j = 0; j <= i; ++j) {
                int x = max(a[i].first, a[j].first);
                int y = max(a[i].second, a[j].second);
                int l = -1, r = now.size();
                while (l + 1 < r) {
                    int m = (l + r) / 2;
                    if (now[m] <= y)
                        l = m;
                    else
                        r = m;
                }
                int ll = -1, rr = now.size();
                while (ll + 1 < rr) {
                    int m = (ll + rr) / 2;
                    if (now[m] < y - h)
                        ll = m;
                    else
                        rr = m;
                }
                mx = max(mx, l - rr + 1);
            }
        }
        cout << mx;
        return 0;
    }
    vector<pair<int, int> > a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin(), a.end());
    int mx = 0, p1 = 0;
    for (int i = 0; i < n; ++i) {
        update(a[i].second, min(MX, a[i].second + h + 1), 1);
        while (p1 < n && a[p1].first < a[i].first - w) {
            update(a[p1].second, min(MX, a[p1].second + h + 1), -1);
            p1++;
        }
        mx = max(mx, tree[0]);
    }
    cout << mx;
}