#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

#define int long long

using namespace std;

vector < pair < int, int > > a;
vector < vector < int > > b;
const int k = 316;
const int sz = 350;
int n, w, h, ans = 0;

void find_ans(int x1, int y1, int x2, int y2)
{
    int kol = 0;
    pair < int, int > p1 = {x1, 0}, p2 = {x2 + 1, 0};
    int l = lower_bound(a.begin(), a.end(), p1) - a.begin();
    int r = upper_bound(a.begin(), a.end(), p2) - a.begin() - 1;
    int nl = a[l].first / k;
    int nr = a[r].first / k;
    if(nl == nr)
    {
        for(int i = l; i <= r; i++)
            if(a[i].first >= x1 && a[i].first <= x2 && a[i].second >= y1 && a[i].second <= y2)
                kol++;
        ans = max(ans, kol);
        return;
    }
    while(a[l].first < min(k * (nl + 1), n))
    {
        if(a[l].first >= x1 && a[l].first <= x2 && a[l].second >= y1 && a[l].second <= y2)
            kol++;
        l++;
    }
    for(int i = nl + 1; i < nr; i++)
    {
        int x = lower_bound(b[i].begin(), b[i].end(), y1) - b[i].begin();
        int y = upper_bound(b[i].begin(), b[i].end(), y2) - b[i].begin() - 1;
        ans += y - x + 1;
    }
    while(a[r].first > k * nr)
    {
        if(a[r].first >= x1 && a[r].first <= x2 && a[r].second >= y1 && a[r].second <= y2)
            kol++;
        r--;
    }
    ans = max(ans, kol);
    return;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> h >> w;
    a.resize(n);
    b.resize(sz);
    for(int i = 0; i < n; i++)
        cin >> a[i].first >> a[i].second;
    sort(a.begin(), a.end());
    for(int i = 0; i < n; i++)
        b[a[i].first / k].push_back(a[i].second);
    for(int i = 0; i < sz; i++)
        sort(b[i].begin(), b[i].end());
    for(int i = 0; i < n; i++)
    {
        find_ans(a[i].first, a[i].second, min(100000ll, a[i].first + w), min(100000ll, a[i].second + h));
        find_ans(max(1ll, a[i].first - w), a[i].second, a[i].first, min(100000ll, a[i].second + h));
        find_ans(a[i].first, max(1ll, a[i].second - h), min(100000ll, a[i].first + w), a[i].second);
        find_ans(max(1ll, a[i].first - w), max(1ll, a[i].second - h), a[i].first, a[i].second);
    }
    cout << ans;
    return 0;
}
