#include <iostream>
#include <vector>

using namespace std;

const int N = 5e4 + 7, M = 5e5 + 7;
const long long INF = 1e16;

namespace Rmq {

    long long rmq[20][N];
    int log2[N];
    int n;

    void Rmq(long long *v, int _n) {
        n = _n;
        for (int i = 1; i <= n; ++i)
            rmq[0][i] = v[i];
        for (int i = 2; i <= n; ++i)
            log2[i] = log2[i / 2] + 1;
        for (int k = 1; (1<<(k - 1)) < n; ++k) {
            for (int i = 1; i + (1<<(k - 1)) <= n; ++i)
                rmq[k][i] = max(rmq[k - 1][i], rmq[k - 1][i + (1<<(k - 1))]);
        }
    }

    long long Query(int st, int dr) {
        if (st > dr)
            return -INF;
        return max(rmq[log2[dr - st + 1]][st], rmq[log2[dr - st + 1]][dr - (1<<log2[dr - st + 1]) + 1]);
    }
}

long long sum[N];
int v[N];

int main()
{
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> v[i];
    long long summax(-INF);
    for (int i = 1; i <= n; ++i) {
        for (int j = i; j <= n; j += i)
            sum[i] += v[j];
        summax = max(summax, sum[i]);
    }
    Rmq::Rmq(sum, n);
    int m, p;
    long long s, total(0);
    cin >> m;
    for (int i = 1; i <= m; ++i) {
        cin >> p >> s;
        int a(1);
        long long ans(0);
        vector < int > div;
        while (1LL * a * a < 1LL * p) {
            if (p % a == 0) {
                ans = max(ans, max(sum[a], sum[p / a]) + s);
                div.push_back(a);
            }
            ++a;
        }
//        int mar = div.size() - 1;
//        for (int i = mar; i >= 0; --i)
//            div.push_back(p / div[i]);
//        div.push_back(n + 1);
//        for (int i = 0; i < div.size() - 1; ++i) {
////            cout << Rmq::Query(div[i] + 1, div[i + 1] - 1) << ' ';
//            ans = max(ans, Rmq::Query(div[i] + 1, div[i + 1] - 1));
//        }
////        cout << '\n';
        total += max(summax, ans);
    }
    cout << total;
    return 0;
}
