#pragma GCC optimize("O3")
#include <iostream>
#include <vector>

using namespace std;

const int N = 5e4 + 7, M = 5e5 + 7;
const long long INF = 1e16;

namespace Rmq {

    long long rmq[20][N];
    int log2[N];
    int n;

    void Rmq(long long *v, int _n) {
        n = _n;
        for (int i = 1; i <= n; ++i)
            rmq[0][i] = v[i];
        for (int i = 2; i <= n; ++i)
            log2[i] = log2[i / 2] + 1;
        for (int k = 1; (1<<(k - 1)) < n; ++k) {
            for (int i = 1; i + (1<<(k - 1)) <= n; ++i)
                rmq[k][i] = max(rmq[k - 1][i], rmq[k - 1][i + (1<<(k - 1))]);
        }
    }

    long long Query(int st, int dr) {
        if (st > dr)
            return -INF;
        return max(rmq[log2[dr - st + 1]][st], rmq[log2[dr - st + 1]][dr - (1<<log2[dr - st + 1]) + 1]);
    }
}

vector < int > divizori[N];

void Ciur() {
    for (int i = 1; i < N; ++i)
        for (int j = i; j < N; j += i)
            divizori[j].push_back(i);
}

long long sum[N];
int v[N];

int main()
{
    Ciur();
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
        cin >> v[i], divizori[i].push_back(n + 1);
    long long summax(-INF);
    for (int i = 1; i <= n; ++i) {
        for (int j = i; j <= n; j += i)
            sum[i] += v[j];
        summax = max(summax, sum[i]);
    }
    Rmq::Rmq(sum, n);
    int m, p;
    long long s, total(0);
    cin >> m;
    for (int i = 1; i <= m; ++i) {
        cin >> p >> s;
        int a(1);
        long long ans(0);
        for (int i : divizori[p]) {
            if (i == n + 1)
                break;
            ans = max(ans, sum[i] + s);
        }
        for (int j = 0; j < divizori[p].size() - 1; ++j)
//            cout << Rmq::Query(divizori[i] + 1, divizori[i + 1] - 1) << ' ';
            ans = max(ans, Rmq::Query(divizori[p][j] + 1, divizori[p][j + 1] - 1));
//        cout << '\n';
        total += ans;
    }
    cout << total;
    return 0;
}
