#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <iomanip>
#include <random>
#include <cassert>

using namespace std;

mt19937 rnd;

int compare(int x, int y);

void quick_sort(int l, int r, vector<int> &curr, int k) {
    if (l + 1 >= r) {
        return;
    }
    int m = rnd() % (r - l) + l;
    vector<int> left;
    vector<int> right;
    for (int i = l; i < r; ++i) {
        if (i == m) {
            continue;
        }
        int x = compare(curr[i], curr[m]);
        if (x == curr[i]) {
            right.push_back(curr[i]);
        } else {
            left.push_back(curr[i]);
        }
    }
    curr[left.size() + l] = curr[m];
    for (int i = 0; i < left.size(); ++i) {
        curr[l + i] = left[i];
    }
    for (int i = 0; i < right.size(); ++i) {
        curr[left.size() + i + l + 1] = right[i];
    }
    if (right.size() + 1 < k) {
        quick_sort(l, l + left.size(), curr, k - right.size() - 1);
    }
    quick_sort(l + left.size() + 1, r, curr, k);
}

vector<int> biggest(int n, int k) {
    vector<int> p;
    for (int i = 0; i < n; ++i) {
        p.push_back(i + 1);
    }
    if (k >= 10000) {
        quick_sort(0, n, p, k);
        vector<int> ans;
        for(int i = n - 1; i >= n - k; --i) {
            ans.push_back(p[i]);
        }
        return ans;
    }
    vector<int> curr;
    for(int i = 0; i < n; ++i) {
        int l = -1, r = curr.size();
        if (curr.size() > 4) {
            int x = compare(curr[3], i + 1);
            if (x == curr[3]) {
                r = 3;
            }
        }
        while(l + 1 < r) {
            int m = (l + r) / 2;
            int x = compare(curr[m], i + 1);
            if (x == curr[m]) {
                r = m;
            }
            else {
                l = m;
            }
        }
        //  insert after l
        curr.insert(curr.begin() + l + 1, i + 1);
        if (curr.size() > k) {
            curr.erase(curr.begin());
        }
    }
    reverse(curr.begin(), curr.end());
    return curr;
}