#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <array>
#include <cmath>
#include <iomanip>

using namespace std;

#define int long long

struct segment_tree {
    vector<int> tree;
    vector<int> add;

    void init(int n) {
        tree.assign(n * 4, 0);
        add.assign(n * 4, 0);
    }

    inline void push(int i) {
        add[i * 2 + 1] += add[i];
        add[i * 2 + 2] += add[i];
        add[i] = 0;
    }

    int get_root() {
        return tree[0] + add[0];
    };

    void upd(int i, int l, int r, int ql, int qr, int val) {
        if (qr <= l || r <= ql) {
            return;
        }
        if (ql <= l && r <= qr) {
            add[i] += val;
            return;
        }
        int m = (l + r) / 2;
        push(i);
        upd(i * 2 + 1, l, m, ql, qr, val);
        upd(i * 2 + 2, m, r, ql, qr, val);
        tree[i] = max(tree[i * 2 + 1] + add[i * 2 + 1], tree[i * 2 + 2] + add[i * 2 + 2]);
    }
};

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int w, h;
    cin >> w >> h;
    vector<int> v;
    vector<pair<pair<int, int>, int>> t;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        v.push_back(y);
        t.push_back({{x, -1}, y});
        t.push_back({{x + w, 1}, y});
    }
    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());
    segment_tree st;
    st.init(v.size());
    map<int, int> d;
    for (int i = 0; i < v.size(); ++i) {
        d[v[i]] = i;
    }
    sort(t.begin(), t.end());
    int ans = 0;
    for(pair<pair<int, int>, int> x : t) {
        int up;
        up = upper_bound(v.begin(), v.end(), x.second + h) - v.begin();
        st.upd(0, 0, v.size(), d[x.second], up, -x.first.second);
        ans = max(ans, st.get_root());
    }
    cout << ans;
    return 0;
}
