#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#define int long long
using namespace std;
struct segtree{
    vector<int> tree;
    int size = 1;
    void init(int n){
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, -1e18);
    }
    void set(int i, int v, int x, int lx, int rx){
        if (rx - lx == 1){
            tree[x] = v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m)
            set(i, v, 2 * x + 1, lx, m);
        else
            set(i, v, 2 * x + 2, m, rx);
        tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
    }
    void set(int i, int v){
        set(i, v, 0, 0, size);
    }
    void dif(int i, int s, int x, int lx, int rx){
        if (rx - lx == 1){
            tree[x] -= s;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m)
            dif(i, s, 2 * x + 1, lx, m);
        else
            dif(i, s, 2 * x + 2, m, rx);
        tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
    }
    void dif(int i, int s){
        dif(i, s, 0, 0, size);
    }
    int max_tree(){
        return tree[0];
    }
    void check(){
        for (int i = 0; i < 2 * size - 1; i++)
            cout << tree[i] << ' ';
    }
};
vector<int> all_del(int p){
    if (p == 1)
        return {1};
    int i = 2;
    vector<pair<int, int>> prost;
    while (i * i <= p){
        if (p % i == 0){
            prost.push_back({i, 0});
            while (p % i == 0){
                p /= i;
                prost[prost.size() - 1].second++;
            }
        }
        i++;
    }
    if (p > 1)
        prost.push_back({p, 1});
    vector<int> x(prost.size(), 0);
    x[x.size() - 1] = 1;
    vector<int> res = {1};
    bool flag = true;
    while (flag){
        int g = 1;
        for (int l = 0; l < prost.size(); l++)
            g *= pow(prost[l].first, x[l]);
        res.push_back(g);
        int j = prost.size() - 1;
        while (j > -1 && prost[j].second == x[j]) {
            x[j] = 0;
            j--;
        }
        if (j == -1)
            flag = false;
        else
            x[j]++;
    }
    return res;
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    int sum = 0;
    cin >> n;
    vector<int> a(n);
    vector<int> krol(n, 0);
    segtree find_max;
    find_max.init(n);
    vector<vector<int>> predpod(n);
    for (int i = 0; i < n; i++)
        predpod[i] = all_del(i + 1);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < n; i++){
        for (auto j: predpod[i])
            krol[j - 1] += a[i];
    }
    for (int i = 0; i < n; i++)
        find_max.set(i, krol[i]);
    cin >> m;
    for (int i = 0; i < m; i++){
        int p, s;
        cin >> p >> s;
        for (auto j: predpod[p - 1])
            find_max.dif(j - 1, -s);
        sum += find_max.max_tree();
        for (auto j: predpod[p - 1])
            find_max.dif(j - 1, s);
    }
    cout << sum;
}