#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#define int long long
using namespace std;
struct segtree{
    vector<int> tree;
    int size = 1;
    void init(int n){
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, -1e18);
    }
    void set(int i, int v, int x, int lx, int rx){
        if (rx - lx == 1){
            tree[x] = v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m)
            set(i, v, 2 * x + 1, lx, m);
        else
            set(i, v, 2 * x + 2, m, rx);
        tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
    }
    void set(int i, int v){
        set(i, v, 0, 0, size);
    }
    void dif(int i, int s, int x, int lx, int rx){
        if (rx - lx == 1){
            tree[x] -= s;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m)
            dif(i, s, 2 * x + 1, lx, m);
        else
            dif(i, s, 2 * x + 2, m, rx);
        tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
    }
    void dif(int i, int s){
        dif(i, s, 0, 0, size);
    }
    int max_tree(){
        return tree[0];
    }
    void check(){
        for (int i = 0; i < 2 * size - 1; i++)
            cout << tree[i] << ' ';
    }
};
vector<int> mymerge(vector<int> a, int b){
    vector<int> res;
    int i = 0;
    int j = 0;
    while (i < a.size() && j < a.size()){
        if (a[i] > a[j] * b){
            res.push_back(a[j] * b);
            j++;
        }
        else if (a[i] < a[j] * b){
            res.push_back(a[i]);
            i++;
        }
        else{
            res.push_back(a[i]);
            i++;
            j++;
        }
    }
    for (int l = i; l < a.size(); l++)
        res.push_back(a[l]);
    for (int l = j; l < a.size(); l++)
        res.push_back(a[l] * b);
    return res;
}
vector<vector<int>> predpod;
vector<int> all_del(int p){
    //int i = 2;
    //vector<pair<int, int>> prost;
    //while (i * i <= p){
    //    if (p % i == 0){
    //        prost.push_back({i, 0});
    //        while (p % i == 0){
    //            p /= i;
    //            prost[prost.size() - 1].second++;
    //        }
    //    }
    //    i++;
    //}
    //if (p > 1)
    //    prost.push_back({p, 1});
    //vector<int> x(prost.size(), 0);
    //x[x.size() - 1] = 1;
    //vector<int> res = {1};
    //bool flag = true;
    //while (flag){
    //    int g = 1;
    //    for (int l = 0; l < prost.size(); l++)
    //        g *= pow(prost[l].first, x[l]);
    //    res.push_back(g);
    //    int j = prost.size() - 1;
    //    while (j > -1 && prost[j].second == x[j]) {
    //        x[j] = 0;
    //        j--;
    //    }
    //    if (j == -1)
    //        flag = false;
    //    else
    //        x[j]++;
    //}
    //return res;
    int i = 2;
    while (i * i <= p){
        if (p % i == 0)
            return mymerge(predpod[p / i - 1], i);
        i++;
    }
    return {1, p};
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    int sum = 0;
    cin >> n;
    predpod.assign(n, {1});
    for (int i = 1; i < n; i++)
        predpod[i] = all_del(i + 1);
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    vector<int> krol(n, 0);
    for (int i = 0; i < n; i++){
        for (auto j: predpod[i])
            krol[j - 1] += a[i];
    }
    if (n <= 15000){
        segtree find_max;
        find_max.init(n);
        for (int i = 0; i < n; i++)
            find_max.set(i, krol[i]);
        cin >> m;
        for (int i = 0; i < m; i++){
            int p, s;
            cin >> p >> s;
            for (auto j: predpod[p - 1])
                find_max.dif(j - 1, -s);
            sum += find_max.max_tree();
            for (auto j: predpod[p - 1])
                find_max.dif(j - 1, s);
        }
    }
    else{
        cin >> m;
        int c = *max_element(krol.begin(), krol.end());
        for (int i = 0; i < m; i++){
            int p, s;
            cin >> p >> s;
            int ans_now = c;
            for (int j: predpod[p - 1])
                ans_now = max(ans_now, krol[j - 1] + s);
            sum += ans_now;
        }
    }
    cout << sum;
}