#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include "unordered_set"
#include "map"
#include "climits"
using namespace std;
#define all(x) (x).begin(), (x).end()
struct segtree{
    int size;
    vector<vector<int>> tree;
    void make(int n, vector<vector<int>> a){
        size = 1;
        while(size < n)
            size *= 2;
        tree.assign(size * 2, {});
        for (int i = 0; i < n; ++i) {
            tree[i + size] = a[i];
            sort(all(tree[i + size]));
        }
        for (int i = size - 1; i > 0; --i) {
            merge(all(tree[i * 2]), all(tree[i * 2 + 1]), back_inserter(tree[i]));
        }
    }
    int get(int v, int x){
        return lower_bound(all(tree[v]), x) - tree[v].begin();
    }
    int less(int l, int r, int x){
        l += size;
        r += size;
        int res = 0;
        while(l < r){
            if(l & 1){
                res += get(l, x);
                l += 1;
            }
            if(!(r & 1)){
                res += get(r, x);
                r -= 1;
            }
            l /= 2;
            r /= 2;
        }
        if(l == r){
            res += get(l, x);
        }
        return res;
    }
};
int main(){
    ios::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> crd;
    vector<vector<int>> ycrd(500005, vector<int>{});
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        crd.emplace_back(x, y);
        ycrd[x].push_back(y);
    }
    segtree st;
    st.make(500005, ycrd);
    int ans = 0;
    for (int j = 0; j < n; ++j) {
        int x, y;
        x = crd[j].first;
        y = crd[j].second;
        ans = max(ans, st.less(max(0, x - w), x, y + 1) - st.less(max(0, x - w), x, y - h));
    }
    if(n <= 1000){
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                int x, y;
                x = max(crd[i].first, crd[j].first);
                y = max(crd[i].second, crd[j].second);
                ans = max(ans, st.less(max(0, x - w), x, y + 1) - st.less(max(0, x - w), x, y - h));
            }
        }
    }
    cout << ans;
}