#include <bits/stdc++.h>
using namespace std;

struct segment_tree{
    void insert_data(int size_){
        size = 1;
        while(size < size_){
            size *= 2;
        }
        tree.assign(size * 2 - 1, 0);
        mtree.assign(size * 2 - 1, 0);
    }

    void add(int l, int r, int val){
        add(0, 0, size, l, r, val);
    }

    int operator()(int l, int r){
        return get_seg(0, 0, size, l, r);
    }

    private:
        vector<int> tree;
        vector<int> mtree;
        int size;

        void add(int i_nd, int l_nd, int r_nd, int l, int r, int val){
            if(l_nd >= l && r_nd <= r){
                mtree[i_nd] += val;
                tree[i_nd] += val;
                return;
            } else if(l_nd >= r || r_nd <= l){
                return;
            } else {
                int m_nd = (l_nd + r_nd) / 2;
                add(i_nd * 2 + 1, l_nd, m_nd, l, r, val);
                add(i_nd * 2 + 2, m_nd, r_nd, l, r, val);
                tree[i_nd] = mtree[i_nd] + max(tree[i_nd * 2 + 1], tree[i_nd * 2 + 2]);
            }
        }

        int get_seg(int i_nd, int l_nd, int r_nd, int l, int r){
            if(l_nd >= l && r_nd <= r){
                return tree[i_nd];
            } else if(l_nd >= r || r_nd <= l){
                return 0;
            } else {
                int m_nd = (l_nd + r_nd) / 2;
                return mtree[i_nd] + max(get_seg(i_nd, l_nd, m_nd, l, r), get_seg(i_nd, m_nd, r_nd, l, r));
            }
        }
};

struct point{
    int x, y;
};

signed main(){
    int n, w, h;
    cin >> n >> w >> h;
    vector<point> arr(n);
    vector<int> cprs_x, cprs_y;
    for(auto& x : arr){
        cin >> x.x >> x.y;
        cprs_x.push_back(x.x);
        cprs_y.push_back(x.y);
    }
    stable_sort(cprs_x.begin(), cprs_x.end());
    stable_sort(cprs_y.begin(), cprs_y.end());
    cprs_x.resize(unique(cprs_x.begin(), cprs_x.end()) - cprs_x.begin());
    cprs_y.resize(unique(cprs_y.begin(), cprs_y.end()) - cprs_y.begin());
    vector<vector<int>> x_sorted(cprs_x.size());
    for(auto p : arr){
        int i = lower_bound(cprs_x.begin(), cprs_x.end(), p.x) - cprs_x.begin();
        x_sorted[i].push_back(p.y);
    }
    segment_tree tr;
    tr.insert_data(cprs_y.size());
    int r = 0;
    int ans = 0;
    for(int l = 0; l < cprs_x.size(); l++){
        while(r < cprs_x.size() &&cprs_x[r] - cprs_x[l] <= w){
            for(auto& y : x_sorted[r]){
                int lb = lower_bound(cprs_y.begin(), cprs_y.end(), y) - cprs_y.begin();
                int ub = upper_bound(cprs_y.begin(), cprs_y.end(), y + h) - cprs_y.begin();
                tr.add(lb, ub, 1);
            }
            r++;
        }
        ans = max(ans, tr(0, cprs_y.size()));
        for(auto& y : x_sorted[l]){
            int lb = lower_bound(cprs_y.begin(), cprs_y.end(), y) - cprs_y.begin();
            int ub = upper_bound(cprs_y.begin(), cprs_y.end(), y + h) - cprs_y.begin();
            tr.add(lb, ub, -1);
        }
    }
    cout << ans;
}
