#include <iostream>
#include <vector>
#include <algorithm>

//#define SORT
//#define DEBUGFIND

using namespace std;

typedef long long ll;

struct Bunny{
    Bunny(){
        sweet = 0;
    }
    ll sweet;
    vector<int> speccarrots;
};
struct hipoteza{
    int p;
    ll s;
    vector<int> affected;
};
struct hipotezas{
    int p, i;
};

bool compareHyp(hipotezas a, hipotezas b){
    return a.p < b.p;
}
bool compareBunny(Bunny a, Bunny b){
    return a.sweet < b.sweet;
}

int findHyps(vector<hipotezas>& vec, int carrot);

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    /*======== unosenje podataka ========*/
    int n, k;
    cin >> n;
    vector<Bunny> vec(n);
    vector<ll> sweet(n);
    for(int i = 0; i < n; ++i){
        cin >> sweet[i];
    }
    cin >> k;
    vector<hipoteza> h(k);
    vector<hipotezas> s(k);
    for(int i = 0; i < k; ++i){
        cin >> h[i].p >> h[i].s;
        --h[i].p;
        s[i].p = h[i].p;
        s[i].i = i;
    }
    sort(s.begin(), s.end(), compareHyp);
    int pos;
    for(int i = 0; i < n; ++i){
        for(int j = i; j < n; j = j+i+1){
            vec[i].sweet += sweet[j];
            pos = findHyps(s, j);
            if(pos != -1){
                vec[i].speccarrots.push_back(s[pos].i);
            }
        }
    }
    sort(vec.begin(), vec.end(), compareBunny);
    for(int i = n-1; i >= 0; --i){
        for(int j = 0; j < vec[i].speccarrots.size(); ++j){
            h[vec[i].speccarrots[j]].affected.push_back(i);
        }
    }
    ll sum = 0;
    /*======== racunanje sume ========*/
    for(int i = 0; i < k; ++i){
        if(h[i].s > 0){                                                 //ako se povecava slatkoca
            if(vec[h[i].affected[0]].sweet + h[i].s > vec[n-1].sweet){  //da li ce najveci koji se povecava postati veci od najvece slatkosti u nizu?
                sum += vec[h[i].affected[0]].sweet + h[i].s;
            }
            else{
                sum += vec[n-1].sweet;
            }
        }
        else{                                                           //ako se smanjuje slatkoca
            bool found = false;
            if(h[i].affected[0] == n-1){
                if(vec[n-1].sweet + h[i].s > vec[n-2].sweet){
                    sum += vec[n-1].sweet + h[i].s;
                    found = true;
                }
                else{
                    for(int j = 1; j < h[i].affected.size(); ++j){
                        if(h[i].affected[j] != h[i].affected[j-1]-1){
                            if(vec[h[i].affected[j-1]-1].sweet > vec[n-1].sweet + h[i].s){
                                sum += vec[h[i].affected[j-1]-1].sweet;
                                found = true;
                            }
                            else{
                                sum += vec[n-1].sweet + h[i].s;
                                found = true;
                            }
                            break;
                        }
                        if(vec[h[i].affected[j]].sweet + h[i].s > vec[h[i].affected[j]-1].sweet){
                            sum += vec[n-1].sweet + h[i].s;
                            found = true;
                        }
                    }
                    if(!found){
                        if(vec[h[i].affected[h[i].affected.size()-1]-1].sweet > vec[n-1].sweet + h[i].s){
                            sum += vec[h[i].affected[h[i].affected.size()-1]-1].sweet;
                        }
                        else{
                            sum += vec[n-1].sweet + h[i].s;
                        }
                    }
                }
            }
        }
    }
    cout << sum << endl;
    return 0;
}

int findHyps(vector<hipotezas>& vec, int carrot){
    /*======== deklarisanje varijabli i proveravanje dal je resenje na pocetku ili kraju ========*/
    int beg = 0, end = vec.size()-1;
    if(vec[end].p == carrot){       //da li je resenje na kraju?
        return end;
    }
    if(vec[beg].p == carrot){       //da li je resenje na pocetku?
        return beg;
    }
    int mid = (beg + end)/2;        //racunanje mid-a
    while(beg < end-1){
        if(vec[mid].p == carrot){   //ako je mid resenje
            return mid;
        }
        if(vec[mid].p < carrot){    //ako se resenje nalazi posle mida
            beg = mid;
        }
        else{                       //ako se resenje nalazi pre mida
            end = mid;
        }
        mid = (beg + end)/2;        //racunanje mida
    }
    return -1;                      //ako resenje nije nadjeno
}

#ifdef SORT
    cout << "s = { (" << s[0].p << ", " << s[0].i << ")";
    for(int i = 1; i < k; ++i){
        cout << ", (" << s[i].p << ", " << s[i].i << ")";
    }
    cout << " };\n";
    cout << "vec = { (" << vec[0].sweet << ", {";
    if(vec[0].speccarrots.size() > 0){
        cout << " " << vec[0].speccarrots[0];
        for(int j = 1; j < vec[0].speccarrots.size(); ++j){
            cout << ", " << vec[0].speccarrots[j];
        }
    }
    cout << " })";
    for(int i = 1; i < n; ++i){
        cout << ", (" << vec[i].sweet << ", {";
        if(vec[i].speccarrots.size() > 0){
            cout << " " << vec[i].speccarrots[0];
            for(int j = 1; j < vec[i].speccarrots.size(); ++j){
                cout << ", " << vec[i].speccarrots[j];
            }
        }
        cout << " })";
    }
    cout << " };\n";
    cout << "h = { (" << h[0].p << ", {";
    if(h[0].affected.size() > 0){
        cout << " " << h[0].affected[0];
        for(int j = 1; j < h[0].affected.size(); ++j){
            cout << ", " << h[0].affected[j];
        }
    }
    cout << " })";
    for(int i = 1; i < k; ++i){
        cout << ", (" << vec[i].sweet << ", {";
        if(h[i].affected.size() > 0){
            cout << " " << h[i].affected[0];
            for(int j = 1; j < h[i].affected.size(); ++j){
                cout << ", " << h[i].affected[j];
            }
        }
        cout << " })";
    }
    cout << " };\n";
#endif // SORT
