#include <iostream>
#include <vector>
#include <algorithm>

//#define DEBUGSORT
//#define DEBUGFINDMIN
//#define DEBUGFINDY
//#define DEBUGMAIN
//#define DEBUGY

using namespace std;

typedef unsigned int uint;

class Point{
public:
    uint x, y;
};

bool comparex(Point a, Point b){
    return a.x < b.x;
}

int findMinStart(vector<Point>& vec, int w);
int findMinStartY(vector<uint>& vec, int beg, int end, int h);
int findY(vector<uint>& y, int beg, int end, int target);

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    /*-------- ucitavanje podataka --------*/
    int n, h, w;
    cin >> n >> w >> h;
    vector<Point> points(n+1);                          //skup svih tacaka
    vector<uint> y(n);                                  //skup svih y kordinata nakon sortiranja niza tacaka
    for(int i = 0; i < n; ++i){
        cin >> points[i].x >> points[i].y;
    }
    sort(points.begin(), points.end()-1, comparex);     //sortiranje tacaka po x-osi
    for(int i = 0; i < n; ++i){
        y[i] = points[i].y;                             //unosenje y koordinati u skup y
    }
    points[n].x = points[n-1].x + w + 1;                //zadnja buffer tacka
    points[n].y = points[n-1].y + h + 1;                //beskorisno

    /*======== metoda 2 pokazivaca ========*/
    int p1, p2;                                         //definisanje pokazivaca p1 i p2
    p1 = 0;
    p2 = findMinStart(points, w);                       //trazenje najvece validne vrednosti p2 za p1 = 0
    int y1, y2;
    sort(y.begin(), y.begin() + p2+1);                  //sortiranje podniza niza y koji se nalazi u opsegu p1 i p2
    int max = 0, el;                                    //postavljanje max promenljive na pocetnu vrednost
    int c;
    /*==== while petlja ====*/
    while(p2 < n){
        /*---- 2 pokazivaca po y-osi ----*/
        y1 = p1;
        y2 = findMinStartY(y, p1, p2, h);               //trazenje najvece validne vrednosti y2 za y1
        /*-- while petlja --*/
        while(y2 <= p2){
            if(y[y2] - y[y1] > h){                      //ako y1 i y2 ne mogu pripadati istom pravougaoniku
                ++y1;
            }
            else{                                       //ako y1 i y2 mogu pripadati istom pravougaoniku
                if(y2 - y1 > max){                      //da li je nadjeno resenje koje obuhvata vise elemenata?
                    max = y2-y1;
                }
                ++y2;
            }
        }
        if(p2 == n-1){
            break;
        }
        el = findY(y, p1, p2, points[p1].y);
        while(el > p1){
            c = y[el];
            y[el] = y[el-1];
            y[el-1] = c;
            --el;
        }
        ++p1;
        while(points[p2+1].x - points[p1].x > w){
            el = findY(y, p1, p2, points[p1].y);
            while(el > p1){
                c = y[el];
                y[el] = y[el-1];
                y[el-1] = c;
                --el;
            }
            ++p1;
        }
        while(points[p2+1].x - points[p1].x <= w){
            ++p2;
            el = p2;
            while(y[el] < y[el-1] && el > p1){
                c = y[el];
                y[el] = y[el-1];
                y[el-1] = c;
                --el;
            }
        }
    }
    cout << max+1 << endl;
    return 0;
}

int findMinStart(vector<Point>& vec, int w){
    int beg = 0, end = vec.size()-1;
    int mid = (beg + end)/2;
    while(beg < end-1){
#ifdef DEBUGFINDMIN
        cout << "beg = " << beg << ", mid = " << mid << ", end = " << end << endl;
#endif // DEBUGFINDMIN
        if(vec[mid].x == vec[0].x+w){
            while(mid < vec.size() && vec[mid].x == vec[0].x+w){
                ++mid;
            }
            --mid;
#ifdef DEBUGFINDMIN
            cout << "returned " << mid << endl;
#endif // DEBUGFINDMIN
            return mid;
        }
        if(vec[mid].x < vec[0].x+w){
            beg = mid;
        }
        else{
            end = mid;
        }
        mid = (beg + end)/2;
    }
    while(end > 0 && vec[end].x > vec[0].x+w){
        --end;
    }
#ifdef DEBUGFINDMIN
    cout << "returned " << end << endl;
#endif // DEBUGFINDMIN
    return end;
}

int findMinStartY(vector<uint>& vec, int beg, int end, int h){
    int orend = end;
    int orbeg = beg;
    if(vec[end] == vec[0]+h){
#ifdef DEBUGFINDMIN
        cout << "returned " << end << endl;
#endif // DEBUGFINDMIN
        return end;
    }
    int mid = (beg + end)/2;
    while(beg < end-1){
#ifdef DEBUGFINDMIN
        cout << "beg = " << beg << ", mid = " << mid << ", end = " << end << endl;
#endif // DEBUGFINDMIN
        if(vec[mid] == vec[0]+h){
            while(mid <= orend && vec[mid] == vec[0]+h){
                ++mid;
            }
            --mid;
#ifdef DEBUGFINDMIN
            cout << "returned " << mid << endl;
#endif // DEBUGFINDMIN
            return mid;
        }
        if(vec[mid] < vec[0]+h){
            beg = mid;
        }
        else{
            end = mid;
        }
        mid = (beg + end)/2;
    }
    while(end > orbeg && vec[end] > vec[0]+h){
        --end;
    }
#ifdef DEBUGFINDMIN
    cout << "returned " << end << endl;
#endif // DEBUGFINDMIN
    return end;
}


int findY(vector<uint>& y, int beg, int end, int target){
    if(y[end] == target){
#ifdef DEBUGFINDY
        cout << "returned " << end << endl;
#endif // DEBUGFINDY
        return end;
    }
    if(y[beg] == target){
#ifdef DEBUGFINDY
        cout << "returned " << beg << endl;
#endif // DEBUGFINDY
        return beg;
    }
    int mid = (beg + end)/2;
    while(beg < end-1){
#ifdef DEBUGFINDY
        cout << "beg = " << beg << ", mid = " << mid << ", end = " << end << endl;
#endif // DEBUGFINDY
        if(y[mid] == target){
#ifdef DEBUGFINDY
            cout << "returned " << mid << endl;
#endif // DEBUGFINDY
            return mid;
        }
        if(y[mid] < target){
            beg = mid;
        }
        else{
            end = mid;
        }
        mid = (beg + end)/2;
    }
#ifdef DEBUGFINDY
    cout << "returned " << mid << endl;
#endif // FINDY
    return mid;
}

#ifdef DEBUGSORT
    cout << "points = { (" << points[0].x << ", " << points[0].y << ")";
    for(int i = 1; i < n+1; ++i){
        cout << ", (" << points[i].x << ", " << points[i].y << ")";
    }
    cout << " };\n";
    cout << "y = { " << y[0];
    for(int i = 1; i < n; ++i){
        cout << ", " << y[i];
    }
    cout << " };\n";
#endif // DEBUGSORT

#ifdef DEBUGMAIN
        cout << "p1 = " << p1 << ", p2 = " << p2 << ";\n";
        cout << "points = { (" << points[0].x << ", " << points[0].y << ")";
        for(int i = 1; i < n+1; ++i){
            cout << ", (" << points[i].x << ", " << points[i].y << ")";
        }
        cout << " };\n";
        cout << "y = { " << y[0];
        for(int i = 1; i < n; ++i){
            cout << ", " << y[i];
        }
        cout << " };\n";
#endif // DEBUGMAIN

#ifdef DEBUGY
            cout << "y1 = " << y1 << ", y2 = " << y2 << ";\n";
#endif // DEBUGY
