#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <assert.h>
#include <map>
#include <deque>

using namespace std;
typedef long long ll;
typedef long double ld;

struct p
{
	int x, y;

	p() {}

	p(int x, int y) : x(x), y(y) {}

	bool operator<(const p& b)
	{
		return make_pair(x, y) < make_pair(b.x, b.y);
	}
};

istream& operator>>(istream& cin, p& a)
{
	return cin >> a.x >> a.y;
}

int n;
vector <p> a;
vector <p> b;
vector <int> i_x, j_y;
map <int, int> x_i, y_j;
int e1, e2;
int h, w;

vector <int> t;
vector <vector <int>> c;

deque <p> now;

pair <int, int> find(const p& po)
{
	int ri = po.y;
	int l = 0, r = ri + 1;

	while (l + 1 < r)
	{
		int m = (l + r) >> 1;

		if (j_y[m] + h - 1 >= j_y[po.y])
		{
			r = m;
		}
		else
		{
			l = m;
		}
	}

	int le = r;

	return { le, ri + 1 };
}

inline void add(const p& po, int v)
{
	auto got = find(po);
	int le = got.first, ri = got.second;

	for (int i = le; i < ri; ++i)
	{
		t[i] += v;
	}
}

inline int mx()
{
	int ans = 0;

	for (auto i : t)
	{
		ans = max(ans, i);
	}

	return ans;
}

int ans;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> h >> w;

	a.resize(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
		i_x.push_back(a[i].x);
		j_y.push_back(a[i].y);
	}

	sort(i_x.begin(), i_x.end());
	i_x.resize(unique(i_x.begin(), i_x.end()) - i_x.begin());
	sort(j_y.begin(), j_y.end());
	j_y.resize(unique(j_y.begin(), j_y.end()) - j_y.begin());

	for (int i = 0; i < i_x.size(); ++i)
	{
		x_i[i_x[i]] = i;
	}
	for (int i = 0; i < j_y.size(); ++i)
	{
		y_j[j_y[i]] = i;
	}

	for (auto i : a)
	{
		b.emplace_back(x_i[i.x], y_j[i.y]);
	}

	sort(b.begin(), b.end());
	t.resize(y_j.size());
	c.resize(x_i.size());
	for (auto po : b)
	{
		c[po.x].push_back(po.y);
	}

	for (int i = 0; i < c.size(); ++i)
	{
		for (auto j : c[i])
		{
			now.emplace_back(i, j);
			add(p(i, j), 1);
		}

		while (now.size())
		{
			auto po = now.front();
			if (i_x[po.x] < i_x[i] - w + 1)
			{
				now.pop_front();
				continue;
			}
			break;
		}

		ans = max(ans, mx());
	}

	cout << ans;
	return 0;
}