#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <assert.h>
#include <map>
#include <deque>

using namespace std;
typedef long long ll;
typedef long double ld;

vector <int> t;
vector <int> ta;

void build(int n)
{
	t.assign(n * 4, 0);
	ta.assign(n * 4, 0);
}

inline void recount(int i)
{
	t[i] = max(t[2 * i + 1] + ta[2 * i + 1], t[2 * i + 2] + ta[2 * i + 2]);
}

inline void push(int i)
{
	ta[2 * i + 1] += ta[i];
	ta[2 * i + 2] += ta[i];
	ta[i] = 0;
}

void add(int i, int l, int r, int ql, int qr, int v)
{
	if (ql <= l && r <= qr)
	{
		ta[i] += v;
		return;
	}
	if (qr <= l || r <= ql) return;

	int m = (l + r) >> 1;
	push(i);
	add(2 * i + 1, l, m, ql, qr, v);
	add(2 * i + 2, m, r, ql, qr, v);
	recount(i);
}

int mx()
{
	return t[0] + ta[0];
}

struct p
{
	int x, y;

	p() {}

	p(int x, int y) : x(x), y(y) {}

	bool operator<(const p& b)
	{
		return make_pair(x, y) < make_pair(b.x, b.y);
	}
};

istream& operator>>(istream& cin, p& a)
{
	return cin >> a.x >> a.y;
}

int n;
vector <p> a;
vector <int> j_y;
map <int, int> y_j;
int h, w;

map <int, vector <int>> c;

deque <p> now;

pair <int, int> find(const p& po)
{
	int le = y_j[po.y];
	int ri = upper_bound(j_y.begin(), j_y.end(), po.y + h) - j_y.begin();
	return { le, ri };
}

inline void add(const p& po, int v)
{
	auto got = find(po);
	int le = got.first, ri = got.second;

	add(0, 0, j_y.size(), le, ri, v);
}



int ans;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> w >> h;

	a.resize(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
		j_y.push_back(a[i].y);
	}

	sort(j_y.begin(), j_y.end());
	j_y.resize(unique(j_y.begin(), j_y.end()) - j_y.begin());

	for (int i = 0; i < j_y.size(); ++i)
	{
		y_j[j_y[i]] = i;
	}

	sort(a.begin(), a.end());

	for (auto i : a)
	{
		c[i.x].push_back(i.y);
	}

	build(j_y.size());

	for (auto i : c)
	{
		int x = i.first;

		for (auto y : i.second)
		{
			now.emplace_back(x, y);
			add(p(x, y), 1);
		}

		while (now.size())
		{
			auto po = now.front();
			if (po.x < x - w)
			{
				add(now.front(), -1);
				now.pop_front();
				continue;
			}
			break;
		}

		auto got = mx();
		//cout << got << ' ';
		ans = max(got, ans);
	}

	cout << ans;
	return 0;
}