//
//  main.cpp
//  C
//
//  Created by Ivan Podvorniy on 20.11.2020.
//  Copyright © 2020 Ivan Podvorniy. All rights reserved.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
vector<long long> t;
vector<long long> vals;


void upd(long long p, long long l, long long r, long long ind) {
    if (r - l == 1) {
        t[p] = vals[l];
        return;
    }
    long long m = (l + r) / 2;
    if (ind >= m) {
        upd(2 * p + 2, m, r, ind);
    } else {
        upd(2 * p + 1, l, m, ind);
    }
    t[p] = max(t[2 * p + 1], t[2 * p + 2]);
}

long long get(long long p, long long l, long long r, long long ql, long long qr) {
    if (l >= qr) {
        return -1e18;
    }
    if (r <= ql) {
        return -1e18;
    }
    if (l >= ql && r <= qr) {
        return t[p];
    }
    long long m = (l + r) / 2;
    return max(get(2 * p + 1, l, m, ql, qr), get(2 * p + 2, m, r, ql, qr));
}


long long sol1(int n, vector<int> v, int m, vector<pair<int, long long>> q) {
    t.resize(0);
    vals.resize(0);
    t.resize(4 * n);
    vals.resize(4 * n);
    for (long long i = 1; i <= n; i++) {
        long long summ = 0;
        for (long long j = i; j <= n; j += i) {
            summ += v[j - 1];
        }
        vals[i - 1] = summ;
        upd(0, 0, n, i - 1);
    }

    long long ans = 0;
    
    for (long long i = 0; i < m; i++) {
        long long p, s;
        p = q[i].first;
        s = q[i].second;

        for (long long j = 1; j * j <= p; j++) {
            if (p % j == 0) {
                vals[j - 1] += s;
                upd(0, 0, n, j - 1);
                if (j != p / j) {
                    vals[p / j - 1] += s;
                    upd(0, 0, n, p / j - 1);
                }
            }
        }
        long long res = get(0, 0, n, 0, n);
        ans += res;
        for (long long j = 1; j * j <= p; j++) {
            if (p % j == 0) {
                vals[j - 1] -= s;
                upd(0, 0, n, j - 1);
                if (j != p / j) {
                    vals[p / j - 1] -= s;
                    upd(0, 0, n, p / j - 1);
                }
            }
        }
    }
    return ans;
}

long long sol2(int n, vector<int> v, int m, vector<pair<int, long long>> q) {
    vector<long long> vals(n);
    for (int i = 1; i <= n; i++) {
        long long summ = 0;
        for (int j = i; j <= n; j += i) {
            summ += v[j - 1];
        }
        vals[i - 1] = summ;
    }

    long long ans = 0;
    long long maxx = *max_element(vals.begin(), vals.end());
    for (int i = 0; i < m; i++) {
        int p;
        long long s;
        p = q[i].first;
        s = q[i].second;
        long long now = maxx;
        for (long long j = 1; j * j <= p; j++) {
            if (p % j == 0) {
                now = max(now, vals[j - 1] + s);
                if (j != p / j) {
                    now = max(now, vals[p / j - 1] + s);
                }
            }
        }
        ans += now;
        
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    int m;
    cin >> m;
    vector<pair<int, long long>> q(m);
    bool fl = false;
    for (int i = 0; i < m; i++)
    {
        cin >> q[i].first >> q[i].second;
        if (q[i].second < 0) {
            fl = true;
        }
    }
    if (fl) {
        cout << sol1(n, v, m, q);
    }
    else {
        cout << sol2(n, v, m, q);
    }
}
