//
//  main.cpp
//  D
//
//  Created by Ivan Podvorniy on 20.11.2020.
//  Copyright © 2020 Ivan Podvorniy. All rights reserved.
//

#include <iostream>
#include <random>
#include <algorithm>
#include <vector>


using namespace std;

vector<int> t;
vector<int> mod;

void push(int p) {
    mod[2 * p + 1] += mod[p];
    mod[2 * p + 2] += mod[p];
    t[p] += mod[p];
    mod[p] = 0;
}

void upd(int p, int l, int r, int ql, int qr, int plus) {
    push(p);
    if (l >= qr) {
        return;
    }
    if (r <= ql) {
        return;
    }
    if (l >= ql && r <= qr) {
        mod[p] += plus;
        push(p);
        return;
    }
    int m = (l + r) / 2;
    upd(2 * p + 1, l, m, ql, qr, plus);
    upd(2 * p + 2, m, r, ql, qr, plus);
    t[p] = max(t[2 * p + 1], t[2 * p + 2]);
}

int get(int p, int l, int r, int ql, int qr) {
    push(p);
    if (l >= qr) {
        return -1e9;
    }
    if (r <= ql) {
        return -1e9;
    }
    if (l >= ql && r <= qr) {
        return t[p];
    }
    int m = (l + r) / 2;
    return max(get(2 * p + 1, l, m, ql, qr), get(2 * p + 2, m, r, ql, qr));
}
void print_array() {
    for (int i = 0; i < 7; i++) {
        cout << get(0, 0, 1e5, i, i + 1) << ' ';
    }
    cout << endl;
}
int sol1(int n, int w, int h, vector<pair<int, int>> v) {
    /*
     int m;
     cin >> m;
     t.resize(2e5);
     mod.resize(4e5);
     for (int i = 0; i < m; i++) {
     int t;
     cin >> t;
     if (t == 0) {
     int l, r;
     cin >> l >> r;
     cout << get(0, 0, 1e5, l, r) << endl;
     }
     else {
     int l, r, p;
     cin >> l >> r >> p;
     upd(0, 0, 1e5, l, r, p);
     }
     }*/
    vector<vector<int>> columns(1e5 + 1);
    for (int i = 0; i < n; i++) {
        int x, y;
        x = v[i].first;
        y = v[i].second;
        columns[x].push_back(y);
    }
    t.resize(4000 * 100);
    mod.resize(8000 * 100);
    int maxx = 0;
    for (int i = 0; i < w + 1; i++) {
        for (auto y : columns[i]) {
            upd(0, 0, 1e5, max(0, y - h), y + 1, 1);
        }
    }
    
    maxx = max(maxx, get(0, 0, 1e5, 0, 1e5));
    for (int i = w + 1; i <= 1e5; i++) {
        for (auto y: columns[i]) {
            upd(0, 0, 1e5, max(0, y - h), y + 1, 1);
            
        }
        for (auto y: columns[i - w - 1]) {
            upd(0, 0, 1e5, max(0, y - h), y + 1, -1);
        }
        maxx = max(maxx, get(0, 0, 1e5, 0, 1e5));
        
    }
    return maxx;
}

int sol2(int n, int w, int h, vector<pair<int, int>> v) {
    /*
     int m;
     cin >> m;
     t.resize(2e5);
     mod.resize(4e5);
     for (int i = 0; i < m; i++) {
     int t;
     cin >> t;
     if (t == 0) {
     int l, r;
     cin >> l >> r;
     cout << get(0, 0, 1e5, l, r) << endl;
     }
     else {
     int l, r, p;
     cin >> l >> r >> p;
     upd(0, 0, 1e5, l, r, p);
     }
     }*/
    vector<vector<int>> columns(1e5 + 1);
    for (int i = 0; i < n; i++) {
        int x, y;
        x = v[i].first;
        y = v[i].second;
        columns[x].push_back(y);
    }
    t.resize(4000 * 100);
    mod.resize(8000 * 100);
    int maxx = 0;
    vector<int> arr(1e3 + 1);
    for (int i = 0; i < w + 1; i++) {
        for (auto y : columns[i]) {
            for (int j =  max(0, y - h); j <= y; j++) {
                arr[j]++;
            }
        }
    }
    maxx = max(maxx, *max_element(arr.begin(), arr.end()));
    for (int i = w + 1; i <= 7; i++) {
        for (auto y: columns[i]) {
            for (int j =  max(0, y - h); j <= y; j++) {
                arr[j]++;
            }
        }
        for (auto y: columns[i - w - 1]) {
            for (int j =  max(0, y - h); j <= y ; j++) {
                arr[j]++;
            }
        }
        maxx = max(maxx, *max_element(arr.begin(), arr.end()));
        
    }
    return maxx;
}

int main() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
        
    }
    cout << sol1(n, w, h, v);
}

/*
 10 8 8
 8 9
 20 14
 3 9
 7 8
 3 4
 7 8
 10 19
 6 11
 5 10
 8 2
 */
