//
//  main.cpp
//  D
//
//  Created by Ivan Podvorniy on 20.11.2020.
//  Copyright © 2020 Ivan Podvorniy. All rights reserved.
//

#include <iostream>
#include <random>
#include <map>
#include <algorithm>
#include <vector>


using namespace std;
int create();
void plusMod(int i, int val);
const int SZ = 1e8 + 1303;
struct node {
    int val, mod;
    int l, r;
    
    node(int val, int mod) {
        this->val = val;
        this->mod = mod;
        this->l = 0;
        this->r = 0;
    }
    node() {}
    void push() {
        if (!l) {
            l = create();
        }
        if (!r) {
            r = create();
        }
        plusMod(l, mod);
        plusMod(r, mod);
        val += mod;
        mod = 0;
    }
};

node tree[1000 * 1000];
int now = 0;
void plusMod(int i, int val) {
    tree[i].mod += val;
}
int create() {
    tree[now] = node(0, 0);
    now++;
    return now - 1;
}

void upd(int p, int l, int r, int ql, int qr, int plus) {
    if (l >= qr) {
        return;
    }
    if (r <= ql) {
        return;
    }
    tree[p].push();
    
    if (l >= ql && r <= qr) {
        tree[p].mod += plus;
        tree[p].push();
        return;
    }
    int m = (l + r) / 2;
    upd(tree[p].l, l, m, ql, qr, plus);
    upd(tree[p].r, m, r, ql, qr, plus);
    tree[p].val = max(tree[tree[p].l].val, tree[tree[p].r].val);
}

int get(int p, int l, int r, int ql, int qr) {
    if (l >= qr) {
        return -1e8 + 1303;
    }
    if (r <= ql) {
        return -1e8 + 1303;
    }
    tree[p].push();
    
    if (l >= ql && r <= qr) {
        return tree[p].val;
    }
    int m = (l + r) / 2;
    return max(get(tree[p].l, l, m, ql, qr), get(tree[p].r, m, r, ql, qr));
}
int p = create();

int maxi(int i, int j) {
    if (i > j) {
        return i;
    }
    return j;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, w, h;
    cin >> n >> w >> h;
    map<int, vector<int>> columns;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        columns[x].push_back(y);
    }
    int maxx = 0;
    auto it = columns.begin();
    for (auto [i, v] : columns) {
        for (auto y: columns[i]) {
            upd(p, 0, SZ, maxi(0, y - h), y + 1, 1);
        }
        while (it->first <= i - w - 1) {
            for (auto y: it->second) {
                upd(p, 0, SZ, maxi(0, y - h), y + 1, -1);
            }
            it++;
        }
        maxx = maxi(maxx, get(p, 0, SZ, 0, SZ));
    }
    cout << maxx << endl;
}

/*
 10 8 8
 8 9
 20 14
 3 9
 7 8
 3 4
 7 8
 10 19
 6 11
 5 10
 8 2
 */
