#include <bits/stdc++.h>
#include <vector>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

#define ios ios_base::sync_with_stdio(0);cout.tie(0);cin.tie(0);
#define int long long
#define len(a) (int)(a).size()
#define all(a) a.begin(),(a).end()

const int INF = 2e17;

struct segtree {
public:
    vector<int> tree;
public:
    vector<int> add;
private:
    vector<int> track;
    int n = 1;

public: explicit segtree(int a) {
        while (n < a)n <<= 1;
        tree.resize(n * 2, 0);

        for (int i = a; i < n; ++i) {
            tree[i+n] = -INF;
        }
        track.resize(n, 0);
        add.resize(n, 0);
    }

private: void push(int t) {
        if ((t << 1) >= n) {
            tree[t << 1] += add[t];
            tree[t << 1 | 1] += add[t];
        } else {
            add[t << 1] += add[t];
            add[t << 1 | 1] += add[t];
        }
        add[t] = 0;
    }
public:
    void update(int l, int r, int v) {
        if(v==1)++track[l];
        if(v==-1)--track[l];
        update(1, 0, n - 1, l, r, v);

    }

private:
    void update(int t, int tl, int tr, int l, int r, int v) {
        if (r < tl || tr < l)return;
        if (l <= tl && tr <= r) {
            if (t < n)
                add[t] += v;
            else
                tree[t] += v;
            return;
        }
        push(t);
        update(t << 1, tl, (tl + tr) >> 1, l, r, v);
        update(t << 1 | 1, ((tl + tr) >> 1) + 1, tr, l, r, v);
        if(t<<1 < n) {
            int v1 = tree[t << 1] + add[t << 1];
            int v2 = tree[t << 1 | 1] + add[t << 1 | 1];
            tree[t] = max(v1, v2);
        }else{
            int v1 = (track[(t<<1)-n] > 0 ? tree[t << 1] : 0);
            int v2 = (track[(t<<1|1)-n] > 0 ? tree[t << 1 | 1] : 0);
            tree[t] = max(v1, v2);
        }
    }
};

struct e {
    int x, id;
    bool type;
};

static bool cmp(e ev1, e ev2){
    if(ev2.x == ev1.x){
        return ev2.type<ev1.type;
    }
    return ev2.x>ev1.x;
}

struct d {
    int x, y;
};

void solve() {
    int n, w, h;
    cin >> n >> w >> h;
    vector<d> dot(n);
    set<int> y;
    for (int i = 0; i < n; ++i) {
        cin >> dot[i].x >> dot[i].y;
        y.insert(dot[i].y);
    }
    unordered_map<int, pair<int, int>> y_to_lr(n);
    vector<int> unique_y;
    for (int it : y){
        unique_y.push_back(it);
    }
    for (int i = 0; i < len(unique_y); ++i) {
        int r = len(unique_y), l = i;
        while(r>l+1){
            int m = (r+l)/2;
            if(unique_y[m]>unique_y[i]+h){
                r = m;
            }else{
                l = m;
            }
        }
        y_to_lr[unique_y[i]] = {i, l};
    }
    segtree st(len(unique_y));
    vector<e> event(n*2);
    for (int i = 0; i < n; ++i) {
        event[i*2] = {dot[i].x - w, i, true};
        event[i*2+1] = {dot[i].x, i, false};
    }
    sort(all(event), cmp);
    int ans = 0;
    for (e i: event) {
        if(i.type){
            st.update(y_to_lr[dot[i.id].y].first, y_to_lr[dot[i.id].y].second, 1);
            ans = max(ans, st.tree[1] + st.add[1]);
        }else{
            st.update(y_to_lr[dot[i.id].y].first, y_to_lr[dot[i.id].y].second, -1);
        }
    }
    cout << ans << endl;
    /*
     Step 1:
        Build tree.
        Size of the tree is equal to amount of unique y's.
        Create -b-o-o-l- int vector, to keep track of 'online' dots.
        Match dots with their segments.
     Step 2:
        Create event vector.
        Sort it by x-coordinate.
        Match events with their segments.
     Step 3:
        Go through the event vector.
        IF e.type == del:
            --track[dot[e.id].y];
            st.add(left[e.id], right[e.id], -1);
            ans = max(st.top, ans);
        ELSE:
            ++track[dot[e.id].y];
            st.add(left[e.id], right[e.id], 1);
            ans = max(st.top, ans);
     Step 4:
        cout << ans << endl;
     */
}

signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios;
    solve();
    return 0;
}