#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
const ll INF = 3e18;

vector <ll> t, all;

void build(int v, int l, int r) {
    if (l == r) {
        t[v] = all[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}


void update(int v, int l, int r, int i, ll x) {
    if (l > i || i > r) return;
    if (l == r) {
        t[v] = x;
        return;
    }
    int m = (l + r) / 2;
    update(2 * v, l, m, i, x);
    update(2 * v + 1, m + 1, r, i, x);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

int solve1(int n, int m, vector <int>& a, vector <pair <int, int>>& z) {
    int len = 1 << (int)ceil(log2(n));
    t.assign(2 * len, 0);
    all.assign(len, -INF);
    for (int i = 0; i < n; ++i) {
        all[i] = 0;
        for (int j = i; j < n; j += i + 1) {
            all[i] += a[j];
        }
    }
    build(1, 0, len - 1);
    vector <ll> del(n, -INF), ndel(n, -INF);
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j * j <= (i + 1); ++j) {
            if ((i + 1) % j == 0) {
                update(1, 0, len - 1, j - 1, -INF);
                del[i] = max(del[i], all[j - 1]);
                update(1, 0, len - 1, (i + 1) / j - 1, -INF);
                del[i] = max(del[i], all[(i + 1) / j - 1]);
            }

        }
        ndel[i] = t[1];
        for (int j = 1; j * j <= (i + 1); ++j) {
            if ((i + 1) % j == 0) {
                update(1, 0, len - 1, j - 1, all[j - 1]);
                update(1, 0, len - 1, i / j - 1, all[i / j - 1]);
            }
        }
    }
    ll sum = 0;
    for (int i = 0; i < m; ++i) {
        sum += max(del[z[i].first - 1] + z[i].second, ndel[z[i].first - 1]);
    }
    return sum;
}

int solve2(int n, int m, vector <int>& a, vector <pair <int, int>>& z) {
    int sum = 0;
    for (int i = 0; i < m; ++i) {
        int maxx = -INF;
        for (int j = 1; j <= n; ++j) {
            int cur = 0;
            for (int k = j; k <= n; k += j) {
                cur += a[k - 1];
                if (k == z[i].first) cur += z[i].second;
            }
            maxx = max(maxx, cur);
        }
        sum += maxx;
    }
    return sum;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    int m;
    cin >> m;
    vector <pair <int, int>> z(m);
    for (int i = 0; i < m; ++i) cin >> z[i].first >> z[i].second;
    cout << solve2(n, m, a, z);
    return 0;
}

