#include <bits/stdc++.h>

using namespace std;

#define ll long long
int len;
const ll INF = 3e18;

vector<ll> t, all;

inline ll max(const ll& a, const ll& b) {
    if (a < b) return b;
    return a;
}

void build(int v, int l, int r) {
    if (l == r) {
        t[v] = all[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}


inline void update(int v, int l, int r, int i, ll x) {
    i += len;
    t[i] = x;
    i >>= 1;
    while (i > 0) {
        t[i] = max(t[2 * i], t[2 * i + 1]);
        i >>= 1;
    }
}

ll solve1(int n, int m, vector<int> &a, vector<pair<int, ll>> &z) {
    len = 1 << (int) ceil(log2(n));
    t.assign(2 * len, 0);
    all.assign(len, -INF);
    for (int i = 0; i < n; ++i) {
        all[i] = 0;
        for (int j = i; j < n; j += i + 1) {
            all[i] += a[j];
        }
    }
    build(1, 0, len - 1);
    vector<ll> del(n, -INF), ndel(n, -INF);
    for (int i = 0; i < n; ++i) {
        for (int j = 1; j * j <= (i + 1); ++j) {
            if ((i + 1) % j == 0) {
                update(1, 0, len - 1, j - 1, -INF);
                del[i] = max(del[i], all[j - 1]);
                update(1, 0, len - 1, (i + 1) / j - 1, -INF);
                del[i] = max(del[i], all[(i + 1) / j - 1]);
            }
        }
        ndel[i] = t[1];
        for (int j = 1; j * j <= (i + 1); ++j) {
            if ((i + 1) % j == 0) {
                update(1, 0, len - 1, j - 1, all[j - 1]);
                update(1, 0, len - 1, (i + 1) / j - 1, all[(i + 1) / j - 1]);
            }
        }
    }
    ll sum = 0;
    for (int i = 0; i < m; ++i) {
        sum += max(del[z[i].first - 1] + z[i].second, ndel[z[i].first - 1]);
    }
    return sum;
}


signed main() {
    srand(time(nullptr));
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    cin >> m;
    vector<pair<int, ll>> z(m);
    for (int i = 0; i < m; ++i) cin >> z[i].first >> z[i].second;
    cout << solve1(n, m, a, z);
    return 0;
}

