#include <bits/stdc++.h>

using namespace std;
const int INF = 1e8;
vector <int> t, p;
vector <pair <int, int>> all_seg;

void push(int v) {
    t[2 * v] += p[v];
    t[2 * v + 1] += p[v];
    p[2 * v] += p[v];
    p[2 * v + 1] += p[v];
    p[v] = 0;
}

void update(int v, int l, int r, int A, int B, int x) {
    if (l > B || A > r) return;
    if (A <= l && r <= B) {
        t[v] += x;
        p[v] += x;
        return;
    }
    push(v);
    int m = (l + r) / 2;
    update(2 * v, l, m, A, B, x);
    update(2 * v + 1, m + 1, r, A, B, x);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

int main() {
    int n, w, h;
    cin >> n >> w >> h;
    vector <pair <int, int>> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i].first >> a[i].second;
    vector <int> ally = {0, INF};
    for (int i = 0; i < n; ++i) ally.push_back(a[i].second);
    sort(ally.begin(), ally.end());
    for (int i = 0; i < ally.size(); ++i) {
        int l = ally[i];
        int r = ally[i] + h;
        all_seg.emplace_back(l, r);
        r = ally[i];
        l = r - h;
        all_seg.emplace_back(l, r);
    }
    sort(all_seg.begin(), all_seg.end());
    vector <int> all_starts = {0};
    for (int i = 0; i < n; ++i) {
        all_starts.push_back(a[i].first);
    }
    sort(a.begin(), a.end());
    sort(all_starts.begin(), all_starts.end());
    int len = 1 << (int)ceil(log2(all_seg.size()));
    t.assign(2 * len, 0);
    p.assign(2 * len, 0);
    vector <pair <int, int>> seg(n);
    for (int i = 0; i < n; ++i) {
        auto it = lower_bound(all_seg.begin(), all_seg.end(), make_pair(a[i].second - h, -INF));
        int l = it - all_seg.begin();
        it = lower_bound(all_seg.begin(), all_seg.end(), make_pair(a[i].second + 1, -INF));
        int r = it - all_seg.begin() - 1;
        seg[i] = make_pair(l, r);
    }
    int cur1 = n - 1, cur2 = n - 1, maxx = 0;
    for (int i = (int)all_starts.size() - 1; i >= 0; --i) {
        while (cur1 >= 0 && a[cur1].first >= all_starts[i]) {
            update(1, 0, len - 1, seg[cur1].first, seg[cur1].second, 1);
            --cur1;
        }
        while (cur2 >= 0 && a[cur2].first > all_starts[i] + w) {
            update(1, 0, len - 1, seg[cur2].first, seg[cur2].second, -1);
            --cur2;
        }
        maxx = max(maxx, t[1]);
    }
    t.assign(2 * len, 0);
    p.assign(2 * len, 0);
    vector <int> all_ends = {INF};
    for (int i = 0; i < n; ++i) {
        all_ends.push_back(a[i].first);
    }
    sort(all_ends.begin(), all_ends.end());
    cur1 = 0;
    cur2 = 0;
    for (int i = 0; i < all_ends.size(); ++i) {
        while (cur1 < n && a[cur1].first <= all_ends[i]) {
            update(1, 0, len - 1, seg[cur1].first, seg[cur1].second, 1);
            ++cur1;
        }
        while (cur2 < n && a[cur2].first < all_ends[i] - w) {
            update(1, 0, len - 1, seg[cur2].first, seg[cur2].second, -1);
            ++cur2;
        }
        maxx = max(maxx, t[1]);
    }
    cout << maxx;
    return 0;
}
