#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <bitset>
#include <stack>
#include <unordered_set>
#include <cmath>

using namespace std;

const int N = 50003, M = 500003;

long long a[N], r[N];
long long segtree[4 * N];

void build(int v, int tl, int tr)
{
	if (tl == tr)
	{
		segtree[v] = r[tl];
		return;
	}

	int m = (tl + tr) / 2;
	build(2 * v, tl, m);
	build(2 * v + 1, m + 1, tr);
	segtree[v] = max(segtree[2 * v], segtree[2 * v + 1]);
}

void update(int v, int tl, int tr, long long p, long long x)
{
	if (tl == tr)
	{
		segtree[v] += x;
		return;
	}

	int m = (tl + tr) / 2;
	if (p <= m)
		update(2 * v, tl, m, p, x);
	else
		update(2 * v + 1, m + 1, tr, p, x);
	segtree[v] = max(segtree[2 * v], segtree[2 * v + 1]);
}

void precalc(int n)
{
	long long ans = 0;
	for (int i = 1; i <= n; i++)
	{
		for (int k = i; k <= n; k += i)
		{
			r[i] += a[k];
		}
		//cout << r[i] << ' ';
		ans = max(ans, r[i]);
	}
	//cout << endl;
}

int main()
{
	int n;
	cin >> n;
	for (int i = 1; i <= n; i++)
	{
		cin >> a[i];
	}
	precalc(n);
	build(1, 1, n);
	//cout << segtree[1] << endl;
	int m;
	cin >> m;
	long long l = 0;
	while (m--)
	{
		long long p, s;
		cin >> p >> s;
		for (long long k = 1; k * k <= p; k++)
		{
			if (p % k == 0)
			{
				update(1, 1, n, k, s);
				update(1, 1, n, p / k, s);
			}
		}
		l += segtree[1];
		//cout << l << endl;
		for (long long k = 1; k * k <= p; k++)
		{
			if (p % k == 0)
			{
				update(1, 1, n, k, -s);
				if (k != p / k)
				update(1, 1, n, p / k, -s);
			}
		}
	}
	cout << l;
	return 0;
}