#include <bits/stdc++.h>
#define debug(x) cerr << #x << " " << x << '\n'
//#pragma GCC optimize "O3"
//#pragma GCC optimize ("Ofast")

using namespace std;
using ll = long long;

const int N = 5e4;
const int M = 5e5;
const long long INF = 10000000000000;

void SetIO() {
#ifdef BLAT
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif // BLAT
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

ll dp[5 + N];
ll v[5 + N];
pair <ll, ll> dd[5 + N];
pair <bool, bool> used[5 + N];
ll n, m;

class Segment_Tree {
private:
    ll a[5 + 4 * N];

    void Recalculate(ll node) {
        a[node] = max(a[node << 1], a[node << 1 | 1]);
    }
public:
    void Build(ll node, ll l, ll r) {
        if(l == r) a[node] = dp[l];
        else {
            ll mid = (l + r) >> 1;

            if(l <= mid) Build(node << 1, l, mid);
            if(r > mid) Build(node << 1 | 1, mid + 1, r);

            Recalculate(node);
        }
    }

    /*void Update(int node, int l, int r, int pos, int val) {
        if(l == r) {
            a[node] = val;
        } else {
            int mid = (l + r) >> 1;
            if(pos <= mid) Update(node << 1, l, mid, pos, val);
            else Update(node << 1 | 1, mid + 1, r, pos, val);

            Recalculate(node);
        }
    }*/

    ll Query(ll node, ll l, ll r, ll x, ll y) {
        if(x <= l && r <= y) return a[node];
        ll mid = (l + r) >> 1;

        if(x <= mid && y <= mid) return Query(node << 1, l, mid, x, y);
        else if(x > mid && y > mid) return Query(node << 1 | 1, mid + 1, r, x, y);
        else return max(Query(node << 1, l, mid, x, mid), Query(node << 1 | 1, mid + 1, r, mid + 1, y));
    }
};
Segment_Tree aint;

/*void Add(ll i) {
    ll d = 1;
    for(d = 1; d * d < i; d++) {
        if(i % d == 0) {
            dp[d] += v[i];
            dp[i / d] += v[i];
        }
    }
    if(d * d == i) dp[d] += v[i];
}*/

void Add(ll i) {
    for(ll j = i; j <= n; j += i)
        dp[i] += v[j];
}

/*void Update1(ll i) {
    ll d = 1;
    for(d = 1; d * d < i; d++) {
        if(i % d == 0) {
            if(used[i].first)
                dd[i].first = max(dd[i].first, dp[d]);
            else dd[i].first = dp[d];
            dd[i].first = max(dd[i].first, dp[i / d]);
            used[i].first = true;
        }
    }

    if(d * d == i) {
        if(used[i].first)
        dd[i].first = max(dd[i].first, dp[d]);
        else { dd[i].first = dp[d]; used[i].first = true; }
    }
}*/

void Update1(ll i) {
    for(ll j = i; j <= n; j += i)
        dd[j].first = max(dd[j].first, dp[i]);
}

ll lastdiv[5 + N];
void Update2(ll i) {
    for(ll j = i; j <= n; j += i) {
        if(lastdiv[j] + 1 < i)
            dd[j].second = max(dd[j].second, aint.Query(1, 1, n, lastdiv[j] + 1, i - 1));
        lastdiv[j] = i;
    }
}

/*void Update2(ll i) {
    ll d = 1;
    vector <ll> div1, div2;
    div1.clear();
    div2.clear();
    for(d = 1; d * d < i; d++) {
        if(i % d == 0) {
            div1.push_back(d);
            div2.push_back(i / d);
        }
    }

    if(d * d == i) div1.push_back(d);
    if(div2.size())
        reverse(div2.begin(), div2.end());

    for(ll x : div2)
        div1.push_back(x);

    for(ll j = 1; j < div1.size(); j++) {
        ll l, r;
        l = div1[j - 1] + 1;
        r = div1[j] - 1;
        if(l <= r) {
            if(used[i].second)
            dd[i].second = max(dd[i].second, aint.Query(1, 1, n, l, r));
            else {
                dd[i].second = aint.Query(1, 1, n, l, r);
                used[i].second = true;
            }
        }
    }

    if(i < n) {
        if(used[i].second)
        dd[i].second = max(dd[i].second, aint.Query(1, 1, n, i + 1, n));
    else { dd[i].second = aint.Query(1, 1, n, i + 1, n); used[i].second = true; }
    }
}*/

int main() {
    SetIO();
    ll sum(0);
    cin >> n;

    for(ll i = 1; i <= n; i++) {
        cin >> v[i];
        dd[i] = {-INF, -INF};
    }
    for(int i = 1; i <= n; i++) Add(i), debug(dp[i]);

    aint.Build(1, 1, n);
    for(ll i = 1; i <= n; i++) {
        Update1(i);
    }

    for(ll i = 1; i <= n; i++) Update2(i);
    for(ll i = 1; i < n; i++) {
        dd[i].second = max(dd[i].second, aint.Query(1, 1, n, i + 1, n));
    }

    cin >> m;
    for(ll i = 1; i <= m; i++) {
        ll idx, val;
        cin >> idx >> val;

        sum += max(dd[idx].first + val, dd[idx].second);
    }

    cout << sum << '\n';
    return 0;
}
