#include <bits/stdc++.h>
#define endl "\n"
using namespace std;
typedef long long ll;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 1e5 + 200;
pair<int, int> point[N + 1];
vector<int> coord[N + 1];
int cnt[4*N], cnx[N + 1], cny[N + 1];

struct node{
  node *l = 0, *r = 0;
  int val = 0;
  bool changed = false;
};

void build(node *v, int tl, int tr){
  if(tl == tr)
    return;
  int tm = (tl + tr) / 2;
  v->l = new node();
  v->r = new node();
  build(v->l, tl, tm);
  build(v->r, tm + 1, tr);
}

void nw(int k, node *v, node *pr, int tl, int tr){
  if(tl == tr){
    v->val = pr->val + cnt[k];
    return;
  }
  int tm = (tl + tr) / 2;
  if(cnt[k*2+1] == 0)
    v->r = pr->r;
  else
    v->r = new node(),
    nw(k*2+1, v->r, pr->r, tm+1, tr);
  if(cnt[k*2] == 0)
    v->l = pr->l;
  else
    v->l = new node(),
    nw(k*2, v->l, pr->l, tl, tm);
  v->val = v->l->val + v->r->val;
}

int sum(node *v, int tl, int tr, int l, int r){
  if(l > r)
    return 0;
  if(tl == l && tr == r)
    return v->val;
  int tm = (tl + tr) / 2;
  return sum(v->l, tl, tm, l, min(r, tm)) + sum(v->r, tm + 1, tr, max(l, tm + 1), r);
}

int n, w, h;
//void brute(){
//  for(int i = 0; i < n; i ++){
//    auto [x, y] = point[i];
//    for(int a = max(1, x - h)
//  }
//}

inline void add(int y){
  int v = 1, l = 0, r = N;
  while(l != r){
    cnt[v] ++;
    int mid = (l + r) / 2;
    v *= 2;
    if(y <= mid)
      r = mid;
    else
      l = mid + 1, v++;
  }
  cnt[v] ++;
}

inline void rem(int y){
  int v = 1, l = 0, r = N;
  while(l != r){
    cnt[v] --;
    int mid = (l + r) / 2;
    v *= 2;
    if(y <= mid)
      r = mid;
    else
      l = mid + 1, v++;
  }
  cnt[v] --;
}

int brute1(){
  int c[500][500] = {};
  for(int i = 0; i < n; i ++)
    c[point[i].first][point[i].second] ++;
  for(int i = 1; i <= 499; i ++)
    for(int j = 1; j <= 499; j ++)
      c[i][j] += c[i - 1][j] + c[i][j - 1] - c[i - 1][j - 1];
  int ans = 0;
  for(int i = 1; i <= 100; i ++){
    for(int j = 1; j <= 100; j ++){
      ans = max(ans, c[i + w][j + h] - c[i][j + h] - c[i + w][j] + c[i][j]);
    }
  }
  cout << ans;
  exit(0);
}

void trybrute1(){
  int x = w, y = h;
  for(int i = 0; i < n; i ++)
    x = max(x, point[i].first),
    y = max(y, point[i].second);
  if(n <= 100 && x <= 100 && y <= 100)
    brute1();
}

void doSwap(){
  swap(w, h);
  for(int i = 0; i < n; i ++)
    swap(point[i].first, point[i].second);
}

int main () {
  ios_base::sync_with_stdio(0);
  cin.tie(0); cout.tie(0);
  cin >> n >> w >> h;
  for(int i = 0; i < n; i ++){
    int x, y;
    cin >> x >> y;
    point[i] = {x, y};
    coord[x].push_back(y);
    cnx[x] ++;
    cny[y] ++;
  }
  int cx = 0, cy = 0;
  for(int i = 0; i <= N; i ++){
    if(cnx[i]) cx ++;
    if(cny[i]) cy ++;
  }
  if(cy > cx)
    doSwap();
//  if(n <= 1000){
//    brute();
//    return 0;
//  }
//  trybrute1();
  vector<node*> kek(N + 1);
  kek[0] = new node();
  build(kek[0], 0, N);
  for(int i = 1; i <= N; i ++){
    if(coord[i].empty())
      kek[i] = kek[i - 1];
    else{
      for(int ew : coord[i])
        add(ew);
      kek[i] = new node();
      nw(1, kek[i], kek[i - 1], 0, N);
      for(int ew : coord[i])
        rem(ew);

    }
  }
  int ans = 0;
  for(int i = 0; i < n; i ++){
    auto [x, y] = point[i];
    int xl = max(0, x - w - 1);
    int yd = max(0, y - h);
    ans = max(ans, sum(kek[x], 0, N, yd, y) - sum(kek[xl], 0, N, yd, y));
  }
  cout << ans;

}
