#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#define endl "\n"
using namespace std;
typedef long long ll;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int N = 1e5 + 5;
vector<pair<int, int>> point;
vector<int> coord[N + 1];
int cnt[4*N];

const int M = 4e6;
struct node{
  int l = 0, r = 0;
  int val = 0;
  bool changed = false;
} t[M];
int id = 1;

void build(int v, int tl, int tr){
  if(tl == tr)
    return;
  int tm = (tl + tr) / 2;
  t[v].l = ++id;
  t[v].r = ++id;
  build(t[v].l, tl, tm);
  build(t[v].r, tm + 1, tr);
}


void nw(int k, int v, int pr, int tl, int tr){
  if(tl == tr){
    t[v].val = t[pr].val + cnt[k];
    return;
  }
  int tm = (tl + tr) / 2;
  if(cnt[k*2+1] == 0)
    t[v].r = t[pr].r;
  else
    t[v].r = ++id,
    nw(k*2+1, t[v].r, t[pr].r, tm+1, tr);
  if(cnt[k*2] == 0)
    t[v].l = t[pr].l;
  else
    t[v].l = ++id,
    nw(k*2, t[v].l, t[pr].l, tl, tm);
  t[v].val = t[t[v].l].val + t[t[v].r].val;
}

int sum(int v, int tl, int tr, int l, int r){
  if(l > r)
    return 0;
  if(tl == l && tr == r)
    return t[v].val;
  int tm = (tl + tr) / 2;
  return sum(t[v].l, tl, tm, l, min(r, tm)) + sum(t[v].r, tm + 1, tr, max(l, tm + 1), r);
}

int n, w, h;

inline void add(int y){
  int v = 1, l = 0, r = N;
  while(l != r){
    cnt[v] ++;
    int mid = (l + r) / 2;
    v *= 2;
    if(y <= mid)
      r = mid;
    else
      l = mid + 1, v++;
  }
  cnt[v] ++;
}

inline void rem(int y){
  int v = 1, l = 0, r = N;
  while(l != r){
    cnt[v] --;
    int mid = (l + r) / 2;
    v *= 2;
    if(y <= mid)
      r = mid;
    else
      l = mid + 1, v++;
  }
  cnt[v] --;
}


void brute2(){
  sort(point.begin(), point.end());
  int ans = 0;
  for(int i = 0; i < n; i ++){
    int j = (upper_bound(point.begin(), point.end(), make_pair(point[i].first + w, INT_MAX)) - point.begin());
    -- j;
    vector<int> y;
    for(int k = i; k <= j; k ++)
      y.push_back(point[k].second);
    sort(y.begin(), y.end());
    for(int k = 0; k < y.size(); k ++){
      int e = (upper_bound(y.begin(), y.end(), y[k] + h) - y.begin());
      -- e;
      ans = max(ans, e - k + 1);
    }
  }
  cout << ans;
  exit(0);
}


void trybrute2(){
  int x = w, y = h;
  for(int i = 0; i < n; i ++)
    x = max(x, point[i].first),
    y = max(y, point[i].second);
  if(n <= 1000 && x <= 100000000 && y <= 100000000)
    brute2();
}

int main () {
  ios_base::sync_with_stdio(0);
  cin.tie(0); cout.tie(0);
  cin >> n >> w >> h;
//  swap(w, h);
  point.resize(n);
  for(int i = 0; i < n; i ++){
    int x, y;
    cin >> x >> y;
//    swap(x, y);
    point[i] = {x, y};
    if(x <= N)coord[x].push_back(y);
  }
//  if(n <= 1000){
//    brute();
//    return 0;
//  }
  trybrute2();
  for(int i = 0; i < n; i ++){
    auto [x, y] = point[i];
    point.push_back({x + w, y});
    point.push_back({x, y + h});
    point.push_back({x + w, y + h});
  }

  vector<int> kek(N + 1);
  kek[0] = ++id;
  build(kek[0], 0, N);
  for(int i = 1; i <= N; i ++){
    if(coord[i].empty())
      kek[i] = kek[i - 1];
    else{
      for(int ew : coord[i])
        add(ew);
      kek[i] = ++id;
      nw(1, kek[i], kek[i - 1], 0, N);
      for(int ew : coord[i])
        rem(ew);

    }
  }
  int ans = 0;
  for(int i = 0; i < n; i ++){
    auto [x, y] = point[i];
    int xl = max(0, x - w - 1);
    int yd = max(0, y - h);
    ans = max(ans, sum(kek[x], 0, N, yd, y) - sum(kek[xl], 0, N, yd, y));
  }
  cout << ans;

}
