#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define debug(x) cerr << #x << " " << x << "\n"
#define debug_s(x) cerr << #x << " " << x << " "

using namespace __gnu_pbds;
using namespace std;
typedef long long ll;
typedef pair <ll,ll> pii;
typedef tree <pii, null_type, less_equal <pii>, rb_tree_tag, tree_order_statistics_node_update> OST;

const ll NMAX = 200001;
const ll MOD = 1000000007;
const ll BLOCK = 400;

ll n;

class AIB {
    OST aib[NMAX];
public:
    void up(pii x) {
        for(ll i = x.first; i <= NMAX; i += i&(-i))
            aib[i].insert({x.second, x.first});
    }
    void dn(pii x) {
        for(ll i = x.first; i <= NMAX; i += i&(-i))
            aib[i].erase({x.second, x.first});
    }
    ll query(pii x) {
        ll sum = 0;
        for(ll i = x.first; i > 0; i -= i&(-i))
            sum += aib[i].order_of_key({x.second + 1, 0});
        return sum;
    }
    ll q(ll x1, ll y1, ll x2, ll y2) {
        return query({x2, y2}) - query({x1 - 1, y2}) - query({x2, y1 - 1}) + query({x1 - 1, y1 - 1});
    }
} aib;

vector <pii> v;
vector <pii> inc;

int main() {
    // ifstream cin(".in");
    //ofstream cout(".out");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, w, h, i;
    cin >> n >> w >> h;
    for(i = 1; i <= n; i++) {
        int a, b;
        cin >> a >> b;
        a+=h+1;
        b+=w+1;
        swap(a, b);
        aib.up({a, b});
        v.push_back({a, b});

    }
    ll j;
    if(n <= 1000) {
        for(i = 0; i < v.size(); i++) {
            for(j = i + 1; j < v.size(); j++) {
                inc.push_back({v[i].first, v[j].second});
                inc.push_back({v[j].first, v[i].second});
            }
        }
    }
    for(auto x : inc)
        v.push_back(x);
    ll maxim = 0;
    for(i  =0; i < v.size(); i++) {
        maxim = max(maxim, aib.q(v[i].first, v[i].second - w, v[i].first + h, v[i].second));
    }
    cout << maxim;
    return 0;
}
