#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define debug(x) cerr << #x << " " << x << "\n"
#define debug_s(x) cerr << #x << " " << x << " "

using namespace __gnu_pbds;
using namespace std;
typedef long long ll;
typedef pair <ll,ll> pii;
typedef tree <pii, null_type, less_equal <pii>, rb_tree_tag, tree_order_statistics_node_update> OST;

const ll NMAX = 200001;
const ll MOD = 1000000007;
const ll BLOCK = 400;

ll n;

class AIB {
    OST aib[NMAX];
public:
    void up(pii x) {
        for(ll i = x.first; i <= NMAX; i += i&(-i))
            aib[i].insert({x.second, x.first});
    }
    void dn(pii x) {
        for(ll i = x.first; i <= NMAX; i += i&(-i))
            aib[i].erase({x.second, x.first});
    }
    ll query(pii x) {
        ll sum = 0;
        if(x.first <= 0)
            return 0;
        if(x.second <= 0)
            return 0;
        for(ll i = x.first; i > 0; i -= i&(-i))
            sum += aib[i].order_of_key({x.second + 1, 0});
        return sum;
    }
    ll q(ll x1, ll y1, ll x2, ll y2) {
        return query({x2, y2}) - query({x1 - 1, y2}) - query({x2, y1 - 1}) + query({x1 - 1, y1 - 1});
    }
} aib;

vector <pii> v;
vector <pii> inc;

ll s[2001][2001];

int main() {
    // ifstream cin(".in");
    //ofstream cout(".out");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, w, h, i;
    int ox = 0, oy = 0;
    cin >> n >> w >> h;
    for(i = 1; i <= n; i++) {
        int a, b;
        cin >> a >> b;
        a+=h+1;
        b+=w+1;
        swap(a, b);
        aib.up({a, b});
        v.push_back({a, b});
        s[a][b]++;
        ox = max(ox, a);
        oy = max(oy, b);
    }
    ll j;

    for(i  =1 ; i <= ox; i++) {
        for(j = 1; j <= oy; j++) {
            s[i][j] = s[i][j] + s[i - 1][j] + s[i][j - 1] - s[i - 1][j - 1];
        }
    }
    ll maxim = 0;
    for(i = 1; i <= ox; i++) {
        for(j = w; j <= oy; j++) {
            maxim = max(maxim, s[i + h][j] - s[i - 1][j] - s[i + h][j - w - 1] + s[i - 1][j - w - 1]);
        }
    }
    cout << maxim;
    return 0;
}
