#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define debug(x) cerr << #x << " " << x << "\n"
#define debug_s(x) cerr << #x << " " << x << " "

using namespace __gnu_pbds;
using namespace std;
typedef long long ll;
typedef pair <ll,ll> pii;
typedef tree <pii, null_type, less_equal <pii>, rb_tree_tag, tree_order_statistics_node_update> OST;

const ll NMAX = 100001;
const ll MOD = 1000000007;
const ll BLOCK = 400;
const ll CT = NMAX / 10;

int mm[2001][2001];
int s[2001][2001];
pii v[NMAX];
ll n;

class AIB {
    OST aib[NMAX];
public:
    void up(pii x) {
        for(ll i = x.first; i <= NMAX; i += i&(-i))
            aib[i].insert({x.second, x.first});
    }
    void dn(pii x) {
        for(ll i = x.first; i <= NMAX; i += i&(-i))
            aib[i].erase({x.second, x.first});
    }
    ll query(pii x) {
        ll sum = 0;
        for(ll i = x.first; i > 0; i -= i&(-i))
            sum += aib[i].order_of_key({x.second + 1, 0});
        return sum;
    }
    ll q(ll x1, ll y1, ll x2, ll y2) {
        return query({x2, y2}) - query({x1 - 1, y2}) - query({x2, y1 - 1}) + query({x1 - 1, y1 - 1});
    }
} aib;

vector <pii> inc;
vector <pii> vv;

int main() {
    // ifstream cin(".in");
    //ofstream cout(".out");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, i, w, h, oy = 0, ox = 0, j;
    cin >> n >> h >> w;
    if(n > 100 && h > 100 && w > 100 && w <= 1000 && h <= 1000) {
        for(i = 1; i <= n; i++) {
            cin >> v[i].second >> v[i].first;
            v[i].second++;
            v[i].first++;
            ox = max(ox, v[i].first);
            oy = max(oy, v[i].second);
            mm[v[i].first][v[i].second]++;
        }
        for(i = 1; i <= ox; i++) {
            for(j = 1; j <= oy; j++) {
                s[i][j] = mm[i][j] + s[i - 1][j] + s[i][j - 1] - s[i - 1][j - 1];
            }
        }

        int maxim = 0;
        for(i = 1; i <= ox - w; i++) {
            for(j = 1; j <= oy - h; j++) {
                int sum = s[i + w][j + h] - s[i - 1][j + h] - s[i + w][j - 1] + s[i - 1][j - 1];
                maxim = max(maxim, sum);
            }
        }
        cout << maxim;
    } else {
        for(i = 1; i <= n; i++) {
            int a, b;
            cin >> a >> b;
            a++;
            b++;
            swap(a, b);
            aib.up({a, b});
            vv.push_back({a, b});
        }
        ll j;
        for(i = 0; i < vv.size() && inc.size() < CT; i++) {
            for(j = i + 1; j < vv.size() && inc.size() < CT; j++) {
                inc.push_back({v[i].first, v[j].second});
                inc.push_back({v[j].first, v[i].second});
            }
        }
        for(auto x : inc)
            vv.push_back(x);
        ll maxim = 0;
        for(i  =0; i < vv.size(); i++) {
            maxim = max(maxim, aib.q(vv[i].first, vv[i].second - w, vv[i].first + h, vv[i].second));
        }
        cout << maxim;
    }
    return 0;
}
