#include "biggest.h"
#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

std::random_device rd;
std::mt19937 g(rd());

const int N = 1e5;
int K;

std::set<pair<int, int>> res[N];
int v[N];

bool ask (int x, int y) {
    if (x == y)
        return false;
    auto it = res[x].lower_bound({y, -1});
    int ans = -1;
    if (it == res[x].end() || it->first != y) {
        ans = compare(x + 1, y + 1);
        res[x].insert({y, ans});
        if (K < 10000)
        res[y].insert({x, ans});
    } else {
        ans = it->second;
    }
    return ans == x + 1;
}



struct Node {
    int y;
    Node *l, *r;
    Node (int y) : y(y) {};
};

Node* build (int n) {
    vector<Node*> nodes(n);
    for (int i = 0; i < n; ++i)
        nodes[i] = new Node(v[i]);
    vector<Node*> st;
    for (int i = 1; i < n; ++i) {
        while (!st.empty() && ask(nodes[i]->y, st.back()->y)) {
            nodes[i]->l = st.back();
            st.pop_back();
        }
        if (!st.empty())
            st.back()->r = nodes[i];
        st.push_back(nodes[i]);
    }
    return st[0];
}

Node* merge (Node* l, Node* r) {
    if (l == nullptr)
        return r;
    if (r == nullptr)
        return l;
    if (ask(r->y, l->y)) {
        r->l = merge(l, r->l);
        return r;
    } else {
        l->r = merge(l->r, r);
        return l;
    }
}

void sort (int start, int end) {
    if (end - start == 1)
        return;
    int m = (start + end) / 2;
    sort(start, m);
    sort(m, end);
    vector<int> a(end - start);
    for (int i = start; i < end; ++i)
        a[i - start] = v[i];
    std::merge(a.begin(), a.begin() + m - start, a.begin() + m - start, a.end(), v + start, ask);
}

std::vector<int> biggest (int n, int k) {
    //assert(n == N);
    K = k;
    for (int i = 0; i < n; ++i)
        v[i] = i;

    // if (k > n / 2)
    //     k = n - k;

    // std::vector<int> v1(n);
    // for (int i = 0; i < n; ++i)
    //     v1[i] = v[i];

    std::shuffle(v, v + n, g);

    // Node* root = build(n);
    // vector<int> ans(k);
    // for (int i = 0; i < k; ++i) {
    //     ans[i] = root->y + 1;
    //     root = merge(root->l, root->r);
    // }

    // std::partial_sort(v1.begin(), v1.begin() + k, v1.begin() + n, ask);
    // for (int i = 0; i < k; ++i) {
    //     assert(ans[i] - 1 == v1[i]);
    // }
    if (k <= 1000)
        std::partial_sort(v, v + k, v + n, ask);
    else {
        std::nth_element(v, v + k - 1, v + n, ask);

        sort(0, k);
        // std::partial_sort(v1.begin(), v1.begin() + k, v1.begin() + n, ask);
        // for (int i = 0; i < k; ++i)
        //     assert(v1[i] == v[i]);
    }
    std::vector<int> ans(k);
    for (int i = 0; i < k; ++i) {
        ans[i] = v[i] + 1;
        //assert(v[i] == v1[i]);
    }
    return ans;
}