#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

const int INF = 1e9;

const int MAX = 2e8;


struct Node {
	int max = 0, f = 0;
	Node *l = nullptr, *r = nullptr;
	Node () {};
};

void push (Node *v) {
	if (v->l == nullptr)
		v->l = new Node();
	if (v->r == nullptr)
		v->r = new Node();
	v->l->max += v->f;
	v->r->max += v->f;
	v->l->f += v->f;
	v->r->f += v->f;
	v->f = 0;
}

void add (Node *v, int vl, int vr, int l, int r, int a) {
	if (r <= vl || vr <= l)
		return;
	if (l <= vl && vr <= r) {
		v->f += a;
		v->max += a;
		return;
	}
	push(v);
	int m = (vr + vl) / 2;
	add(v->l, vl, m, l, r, a);
	add(v->r, m, vr, l, r, a);
	v->max = std::max(v->l->max, v->r->max);
}



int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);


	int n, w, h;
	cin >> n >> w >> h;
	vector<pair<int, pair<int, int>>> v(2 * n);
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		v[i * 2] = {x, {y, 1}};
		v[i * 2 + 1] = {x + w + 1, {y, -1}};
	}

	std::sort(v.begin(), v.end());

	Node* root = new Node();
	int ans = 0;
	for (int i = 0; i < 2 * n;) {
		int j = i;
		for (; j < 2 * n && v[j].first == v[i].first; ++j)
			add(root, 0, MAX, v[j].second.first, v[j].second.first + h, v[j].second.second);
		ans = std::max(ans, root->max);
		i = j;
	}

	cout << ans;

	return 0;
}