#include <bits/stdc++.h>
using namespace std;

struct node {
  int i, j, val, lazy;
  node *left, *right;
};

node *build(int i, int j) {
  if (i == j) return new node{i, j, 0, 0, nullptr, nullptr};
  node *left = build(i, (i + j) / 2);
  node *right = build((i + j) / 2 + 1, j);
  return new node{i, j, 0, 0, left, right};
}

void propagate(node *cur) {
  if (cur->lazy == 0) return;
  cur->val += cur->lazy;
  if (cur->left != nullptr) cur->left->lazy += cur->lazy, cur->right->lazy += cur->lazy;
  cur->lazy = 0;
}

int query(node *cur, int i, int j) {
  propagate(cur);
  if (cur->i > j || cur->j < i) return 0;
  if (cur->i >= i && cur->j <= j) return cur->val;
  return max(query(cur->left, i, j), query(cur->right, i, j));
}

void update(node *cur, int i, int j, int val) {
  propagate(cur);
  if (cur->i > j || cur->j < i) return;
  if (cur->i >= i && cur->j <= j) {
    cur->lazy += val;
    propagate(cur);
    return;
  }
  update(cur->left, i, j, val);
  update(cur->right, i, j, val);
  cur->val = max(cur->left->val, cur->right->val);
}

struct range_query {
  int x, l, r, val;
};

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, w, h;
  cin >> n >> w >> h;
  vector<int> x(n), y(n);
  int d1 = 0, d2 = 0;
  map<int, int> mp;
  for (int i = 0; i < n; i++) {
    cin >> x[i] >> y[i];
    d1 = max(d1, x[i] + 1);
    d2 = max(d2, y[i] + 1);
    mp[max(0, y[i] - h)]++;
    mp[y[i]]++;
  }
  int idx = 0;
  for (auto& p : mp) p.second = idx++;
  vector<range_query> queries;
  for (int i = 0; i < n; i++) {
    queries.push_back({max(0, x[i] - w), mp[max(0, y[i] - h)], mp[y[i]], +1});
    queries.push_back({x[i] + 1, mp[max(0, y[i] - h)], mp[y[i]], -1});
  }
  sort(queries.begin(), queries.end(), [](const range_query &a, const range_query &b) {
    return a.x < b.x;
  });
  node *root = build(0, d2);
  int prev = -1, ans = 0;
  for (auto& q : queries) {
    if (q.x != prev) {
      ans = max(ans, query(root, 0, d2));
      prev = q.x;
    }
    update(root, q.l, q.r, q.val);
  }
  cout << ans << '\n';
  return 0;
}
