﻿#pragma unroll_loops
//#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <algorithm>
#include <cmath>
#include <map>
#include <iomanip>
#include <string>
#include <unordered_map>
#include <chrono>

using namespace std;

#define ll long long

#define VI vector<int>
#define VB vector<bool>
#define VS vector<string>
#define VC vector<char>
#define PAR pair<int, int>
#define VP vector<PAR>
#define VVI vector<VI>
#define VVC vector<VC>
#define VVB vector<VB>
#define VVP vector<VP>
#define endl '\n'

#define x first
#define y second

istream& operator>>(istream& in, PAR& p) {
	in >> p.first;
	in >> p.second;
	return in;
}

ostream& operator<<(ostream& out, const PAR& p) {
	out << p.first << ' ' << p.second;
	return out;
}

template<class T>
istream& operator>>(istream& in, vector<T>& v) {
	for (int i = 0; i < v.size(); ++i) {
		in >> v[i];
	}
	return in;
}

template<class T>
ostream& operator<<(ostream& out, const vector<T>& v) {
	for (int i = 0; i < v.size(); ++i) {
		out << v[i] << ' ';
	}
	return out;
}

bool rmax(int& a, int b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

bool rmin(int& a, int b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<class T>
bool rmax(T& a, const T& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<class T>
bool rmin(T& a, const T& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

set<PAR> inter(const set<PAR>& a, const set<PAR>& b) {
	set<PAR> res;
	for (PAR p : a) {
		if (b.find(p) != b.end()) {
			res.insert(p);
		}
	}
	return res;
}

bool mcomp2(const PAR& a, const PAR& b) {
	if (a.y < b.y) {
		return true;
	}
	return false;
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, w, h;
	cin >> n >> h >> w;
	VP vp(n);
	cin >> vp;

	map<int, set<PAR>> prefx, prefy;
	sort(vp.begin(), vp.end());
	int prevx = 0;
	for (PAR p : vp) {
		if (p.x != prevx) {
			prefx[p.x] = prefx[prevx];
		}
		prefx[p.x].insert(p);
		prevx = p.x;
	}

	sort(vp.begin(), vp.end(), mcomp2);
	int prevy = 0;
	for (PAR p : vp) {
		if (p.y != prevy) {
			prefy[p.y] = prefy[prevy];
		}
		prefy[p.y].insert(p);
		prevy = p.y;
	}

	int res = 0;

	for (PAR p : vp) {
		int num = inter(prefx[p.x], prefy[p.y]).size() - inter(prefx[p.x], prefy[p.y - h - 1]).size()
			- inter(prefx[p.x - w - 1], prefy[p.y]).size() + inter(prefx[p.x - w - 1], prefy[p.y - h - 1]).size();
		rmax(res, num);
	}

	cout << res << endl;

	return 0;
}
