﻿#pragma unroll_loops
//#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <algorithm>
#include <cmath>
#include <map>
#include <iomanip>
#include <string>
#include <unordered_map>
#include <chrono>

using namespace std;

#define ll long long

#define VI vector<int>
#define VB vector<bool>
#define VS vector<string>
#define VC vector<char>
#define PAR pair<int, int>
#define VP vector<PAR>
#define VVI vector<VI>
#define VVC vector<VC>
#define VVB vector<VB>
#define VVP vector<VP>
#define endl '\n'

#define x first
#define y second

istream& operator>>(istream& in, PAR& p) {
	in >> p.first;
	in >> p.second;
	return in;
}

ostream& operator<<(ostream& out, const PAR& p) {
	out << p.first << ' ' << p.second;
	return out;
}

template<class T>
istream& operator>>(istream& in, vector<T>& v) {
	for (int i = 0; i < v.size(); ++i) {
		in >> v[i];
	}
	return in;
}

template<class T>
ostream& operator<<(ostream& out, const vector<T>& v) {
	for (int i = 0; i < v.size(); ++i) {
		out << v[i] << ' ';
	}
	return out;
}

bool rmax(int& a, int b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

bool rmin(int& a, int b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<class T>
bool rmax(T& a, const T& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<class T>
bool rmin(T& a, const T& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

int inter(const map<PAR, int>& a, const map<PAR, int>& b) {
	int res = 0;
	for (auto p : a) {
		if (b.find(p.first) != b.end()) {
			res += p.second;
		}
	}
	return res;
}

bool mcomp2(const PAR& a, const PAR& b) {
	if (a.y < b.y) {
		return true;
	}
	return false;
}

struct Point : public pair<int, int> {
	int num;
	Point(int x, int y, int num = 0) : PAR(x, y), num(num) {}
	Point() : PAR(), num(0) {}
};


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, w, h;
	cin >> n >> h >> w;
	VP vp(n);
	cin >> vp;

	map<int, map<PAR, int>> prefx, prefy;
	VI xx, yy;
	sort(vp.begin(), vp.end());
	//VP vpy = vp;
	//sort(vpy.begin(), vpy.end(), mcomp2);
	int prevx = 0;
	for (PAR p : vp) {
		if (p.x != prevx) {
			prefx[p.x] = prefx[prevx];
			xx.push_back(p.x);
		}
		prefx[p.x][p]++;
		prevx = p.x;
	}

	sort(vp.begin(), vp.end(), mcomp2);
	int prevy = 0;
	for (PAR p : vp) {
		if (p.y != prevy) {
			prefy[p.y] = prefy[prevy];
			yy.push_back(p.y);
		}
		prefy[p.y][p]++;
		prevy = p.y;
	}

	int res = 0;

	/*for (PAR p : vp) {
		int num = inter(prefx[p.x], prefy[p.y]);
		if (p.x - w - 1 >= xx.front()) {
			num -= inter(prefx[*lower_bound(xx.begin(), xx.end(), p.x - w - 1)], prefy[p.y]);
		}
		if (p.y - h - 1 >= yy.front()) {
			num -= inter(prefx[p.x], prefy[*lower_bound(yy.begin(), yy.end(), p.y - h - 1)]);
		}
		if (p.x - w - 1 >= xx.front() && p.y - h - 1 >= yy.front()) {
			num += inter(prefx[*lower_bound(xx.begin(), xx.end(), p.x - w - 1)], prefy[*lower_bound(yy.begin(), yy.end(), p.y - h - 1)]);
		}

		int num2 = inter(prefx[p.x + w], prefy[p.y]);
		if (p.x - 1 >= xx.front()) {
			num2 -= inter(prefx[*lower_bound(xx.begin(), xx.end(), p.x - 1)], prefy[p.y]);
		}
		if (p.y - h - 1 >= yy.front()) {
			num2 -= inter(prefx[p.x + w], prefy[*lower_bound(yy.begin(), yy.end(), p.y - h - 1)]);
		}
		if (p.x - 1 >= xx.front() && p.y - h - 1 >= yy.front()) {
			num2 += inter(prefx[*lower_bound(xx.begin(), xx.end(), p.x - 1)], prefy[*lower_bound(yy.begin(), yy.end(), p.y - h - 1)]);
		}

		int num3 = inter(prefx[p.x], prefy[p.y + h]);
		if (p.x - w - 1 >= xx.front()) {
			num3 -= inter(prefx[*lower_bound(xx.begin(), xx.end(), p.x - w - 1)], prefy[p.y + h]);
		}
		if (p.y - 1 >= yy.front()) {
			num3 -= inter(prefx[p.x], prefy[*lower_bound(yy.begin(), yy.end(), p.y - 1)]);
		}
		if (p.x - w - 1 >= xx.front() && p.y - 1 >= yy.front()) {
			num3 += inter(prefx[*lower_bound(xx.begin(), xx.end(), p.x - w - 1)], prefy[*lower_bound(yy.begin(), yy.end(), p.y - 1)]);
		}

		int num4 = inter(prefx[p.x + w], prefy[p.y + h]);
		if (p.x - 1 >= xx.front()) {
			num -= inter(prefx[*lower_bound(xx.begin(), xx.end(), p.x - 1)], prefy[p.y + h]);
		}
		if (p.y - 1 >= yy.front()) {
			num -= inter(prefx[p.x + w], prefy[*lower_bound(yy.begin(), yy.end(), p.y - 1)]);
		}
		if (p.x - 1 >= xx.front() && p.y - 1 >= yy.front()) {
			num += inter(prefx[*lower_bound(xx.begin(), xx.end(), p.x - 1)], prefy[*lower_bound(yy.begin(), yy.end(), p.y - 1)]);
		}
		if (rmax(res, num)) {
			cout << 1 << ": " << p << "num: " << num << endl;
		}
		if (rmax(res, num2)) {
			cout << 2 << ": " << p << "num: " << num2 << endl;
		}
		if (rmax(res, num3)) {
			cout << 3 << ": " << p << "num: " << num3 << endl;
		}
		if (rmax(res, num4)) {
			cout << 4 << ": " << p << "num: " << num4 << endl;
		}
	}*/

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			PAR p1 = vp[i], p2 = vp[j];
			if (p1.x == p2.x) continue;
			if (p1.y == p2.y) continue;
			if (p1.x > p2.x) swap(p1, p2);

			PAR p = { p1.x, p2.y };
			if (p1.y < p2.y) {
				p.y -= h;
			}

			int num = inter(
				prefx[*(upper_bound(xx.begin(), xx.end(), p.x + w) - 1)],
				prefy[*(upper_bound(yy.begin(), yy.end(), p.y + h) - 1)]
			);
			if (p.x - 1 >= xx.front()) {
				num -= inter(
					prefx[*(upper_bound(xx.begin(), xx.end(), p.x - 1) - 1)],
					prefy[*(upper_bound(yy.begin(), yy.end(), p.y + h) - 1)]
				);
			}
			if (p.y - 1 >= yy.front()) {
				num -= inter(
					prefx[*(upper_bound(xx.begin(), xx.end(), p.x + w) - 1)],
					prefy[*(upper_bound(yy.begin(), yy.end(), p.y - 1) - 1)]
				);
			}
			if (p.x - 1 >= xx.front() && p.y - 1 >= yy.front()) {
				num += inter(
					prefx[*(upper_bound(xx.begin(), xx.end(), p.x - 1) - 1)],
					prefy[*(upper_bound(yy.begin(), yy.end(), p.y - 1) - 1)]
				);
			}
			if (rmax(res, num)) {
				//cout << p1 << endl << p2 << endl << "Num: " << num << endl;
			}

			p = { p2.x, p1.y };
			if (p1.y < p2.y) {
				p.x += w;
			}

			num = inter(
				prefx[*(upper_bound(xx.begin(), xx.end(), p.x) - 1)],
				prefy[*(upper_bound(yy.begin(), yy.end(), p.y) - 1)]
			);
			if (p.x - w - 1 >= xx.front()) {
				num -= inter(
					prefx[*(upper_bound(xx.begin(), xx.end(), p.x - w - 1) - 1)],
					prefy[*(upper_bound(yy.begin(), yy.end(), p.y) - 1)]
				);
			}
			if (p.y - h - 1 >= yy.front()) {
				num -= inter(
					prefx[*(upper_bound(xx.begin(), xx.end(), p.x) - 1)],
					prefy[*(upper_bound(yy.begin(), yy.end(), p.y - h - 1) - 1)]
				);
			}
			if (p.x - w - 1 >= xx.front() && p.y - h - 1 >= yy.front()) {
				num += inter(
					prefx[*(upper_bound(xx.begin(), xx.end(), p.x - w - 1) - 1)],
					prefy[*(upper_bound(yy.begin(), yy.end(), p.y - h - 1) - 1)]
				);
			}

			if (rmax(res, num)) {
				//cout << p1 << endl << p2 << endl << "Num: " << num << endl;
			}

		}
	}

	cout << res << endl;

	/*
	6 2 3
1 1
3 1
2 2
3 3
5 3
3 5
	*/

	/*
	10 8 8
8 9
20 14
3 9
7 8
3 4
7 8
10 19
6 11
5 10
8 2
	*/
	/*
	3 3 3
	3 1
	1 3
	4 4
	*/

	return 0;
}
