﻿#pragma unroll_loops
//#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <algorithm>
#include <cmath>
#include <map>
#include <iomanip>
#include <string>
#include <unordered_map>
#include <chrono>

using namespace std;

#define ll long long

#define VI vector<int>
#define VB vector<bool>
#define VS vector<string>
#define VC vector<char>
#define PAR pair<int, int>
#define VP vector<PAR>
#define VVI vector<VI>
#define VVC vector<VC>
#define VVB vector<VB>
#define VVP vector<VP>
#define endl '\n'

#define x first
#define y second

istream& operator>>(istream& in, PAR& p) {
	in >> p.first;
	in >> p.second;
	return in;
}

ostream& operator<<(ostream& out, const PAR& p) {
	out << p.first << ' ' << p.second;
	return out;
}

template<class T>
istream& operator>>(istream& in, vector<T>& v) {
	for (int i = 0; i < v.size(); ++i) {
		in >> v[i];
	}
	return in;
}

template<class T>
ostream& operator<<(ostream& out, const vector<T>& v) {
	for (int i = 0; i < v.size(); ++i) {
		out << v[i] << ' ';
	}
	return out;
}

bool rmax(int& a, int b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

bool rmin(int& a, int b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<class T>
bool rmax(T& a, const T& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<class T>
bool rmin(T& a, const T& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

int inter(const map<PAR, int>& a, const map<PAR, int>& b) {
	int res = 0;
	for (auto p : a) {
		if (b.find(p.first) != b.end()) {
			res += p.second;
		}
	}
	return res;
}

bool mcomp2(const PAR& a, const PAR& b) {
	if (a.y < b.y) {
		return true;
	}
	return false;
}

struct Point : public pair<int, int> {
	int num;
	Point(int x, int y, int num = 0) : PAR(x, y), num(num) {}
	Point() : PAR(), num(0) {}
};


signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, w, h;
	cin >> n >> h >> w;
	VP vpx(n);
	cin >> vpx;

	sort(vpx.begin(), vpx.end());

	VI dp(n + 1);
	dp[0] = 0;

	for (int i = 0; i < n; ++i) {
		PAR p = vpx[i];
		int num = 0;
		int j = lower_bound(vpx.begin(), vpx.end(), PAR( p.x - w, -1 )) - vpx.begin();
		VP vpot;
		for (int k = j; k <= i; ++k) {
			if (abs(vpx[i].y - vpx[k].y) <= h) {
				vpot.push_back(vpx[k]);
			}
		}
		sort(vpot.begin(), vpot.end(), mcomp2);

		for (int k = 0; k < vpot.size(); ++k) {
			int edge = upper_bound(vpot.begin(), vpot.end(), PAR(vpx[i].x + 1, vpot[k].y + h), mcomp2) - vpot.begin() - 1;
			rmax(num, edge - k + 1);
		}

		dp[i + 1] = max(dp[i], num);
	}

	cout << dp[n] << endl;

	/*
	6 2 3
1 1
3 1
2 2
3 3
5 3
3 5
	*/

	/*
	10 8 8
8 9
20 14
3 9
7 8
3 4
7 8
10 19
6 11
5 10
8 2
	*/
	/*
	3 3 3
	3 1
	1 3
	4 4
	*/

	return 0;
}
