#include "biggest.h"
#include <bits/stdc++.h>
using namespace std;

bool comp(int a, int b) {
    return compare(a, b) == a;
}

vector<int> merge_sort(vector<int> now, int k) 
{
    if(now.size() < 2) return now;
    int mid = now.size() / 2;
    vector<int> left = merge_sort(vector<int>(now.begin(), now.begin() + mid), k);
    vector<int> right = merge_sort(vector<int>(now.begin() + mid, now.end()), k);
    vector<int> result;
    int l = 0, r = 0, count = 0;
    while(count < k && l < left.size() && r < right.size()) {
        if(comp(left[l], right[r])) {
            result.push_back(left[l]);
            l++;
        } else {
            result.push_back(right[r]);
            r++;
        }
        count++;
    }
    while(count < k && l < left.size()) {
        result.push_back(left[l]);
        l++;
        count++;
    }
    while(count < k && r < right.size()) {
        result.push_back(right[r]);
        r++;
        count++;
    }
    return result;
}

vector<int> linear(int * now, int n, int k) {
    vector<int> result;
    for(int j = 0; j < k; ++j) {
        int max_i = 0;
        for(int i = 1; i < n - j; ++i) {
            if(compare(now[max_i], now[i]) == now[i]) max_i = i;
        }
        result.push_back(now[max_i]);
        swap(now[n - j - 1], now[max_i]);
    }
    return result;
}

vector<int> biggest(int n, int k)
{
    if(ceil(log2(n) + k) > n * k) {
        int * now = new int[n];
        for (int i = 0; i < n; i++)
            now[i] = i + 1;
        return linear(now, n,  k);
    } else {
        vector<int> now(n);
        for (int i = 0; i < n; i++) {
            now[i] = i + 1;
        }
        now = merge_sort(now, k);
        return vector<int>(now.begin(), now.begin() + k);
    }
}