#include <iostream>
#include <cstdio>
#define push_back pb
#include <vector>

using namespace std;

const int NMAX = 5e4;
long long aint[4 * NMAX + 5], v[NMAX + 5], x[NMAX + 5];
long long maxx;
vector <long long> div;

typedef long long ll;

static inline ll max( ll a, ll b ){
  return a < b ? b : a;
}

void build( int nod, int st, int dr ){
  if( st == dr ){
    aint[nod] = x[st];
    return ;
  }
  int med = (st + dr) >> 1;
  build(2 * nod, st, med);
  build(2 * nod + 1, med + 1, dr);
  aint[nod] = max(aint[2 * nod], aint[2 * nod + 1]);
}

void update( int nod, int st, int dr, int a, int b ){
  if( st == dr ){
    aint[nod] += b;
    return ;
  }
  int med = (st + dr) >> 1;
  if( a <= med )
    update(2 * nod, st, med, a, b);
  else
    update(2 * nod + 1, med + 1, dr, a, b);
  aint[nod] = max(aint[2 * nod], aint[2 * nod + 1]);
}

void query( int nod, int st, int dr, int a, int b ){
  if( st == dr ){
    maxx = max(maxx, aint[nod]);
    return ;
  }
  int med = (st + dr) >> 1;
  if( a <= med )
    query(2 * nod, st, med, a, b);
  if( b > med )
    query(2 * nod + 1, med + 1, dr, a, b);
}

int main() {
  freopen( ".in", "r", stdin );
  freopen( ".out", "w", stdout );
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  int n, i, j, m, d, poz;
  long long sum, sol, val, maxime;
  cin >> n;
  for( i = 1; i <= n; ++i )
    cin >> v[i];
  for( i = 1; i <= n; ++i ){
    sum = 0;
    for( j = i; j <= n; j += i )
      sum += v[j];
    x[i] = sum;
  }
  build(1, 1, n);
  cin >> m;
  sol = 0;
  for( i = 1; i <= m; ++i ){
    cin >> poz >> val;
    d = 1; maxime = 0;
    while( d * d < poz ){
      if( poz % d == 0 ){
        update(1, 1, n, d, val);
        update(1, 1, n, poz / d, val);
        div.pb(d); div.pb(poz / d);
      }
      ++d;
    }
    if( d * d == poz )
      update(1, 1, n, d, val);
    maxx = 0; query(1, 1, n, 1, n);
    sol += maxx;
    for( auto it : div ){
      update(1, 1, n, it, -val);
    }
    div.clear();
  }
  cout << sol;
  return 0;
}