//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll inf = 4e18 + 1329;

const int logmaxn = 17;
const int maxn = 50031;

ll st [logmaxn][maxn];

void build(vector<ll>& x) {
    int n = (int) x.size();
    for (int i = 0; i < n; ++i) {
        st[0][i] = x[i];
    }
    for (int l = 1; l < logmaxn; ++l) {
        for (int i = 0; i + (1 << l) <= n; ++i) {
            st[l][i] = max(st[l - 1][i], st[l - 1][i + (1 << (l - 1))]);
        }
    }
}

ll get(int L, int R) {
    if (L >= R) return -inf;
    if (L + 1 == R) return st[0][L];
    int l = 0;
    while ((1 << (l + 1)) <= R - L) {
        l += 1;
    }
    return max(st[l][L], st[l][R - (1 << l)]);
}

signed main() {
    int n; cin >> n;
    vector<int> a (n + 1, 0);
    for (int i = 1; i <= n; ++i) cin >> a[i];
    vector<ll> t (n + 1, 0);
    for (int d = 1; d <= n; ++d) {
        for (int i = d; i <= n; i += d) {
            t[d] += a[i];
        }
    }
    build(t);
    vector<ll> in (n + 1, -inf), out (n + 1, -inf);
    for (int i = 1; i <= n; ++i) {
        vector<int> allk = {0, n + 1};
        for (int k = 1; k * k <= i; ++k) {
            if (i % k != 0) continue;
            in[i] = max(in[i], t[k]);
            in[i] = max(in[i], t[i / k]);
            allk.push_back(k); allk.push_back(i / k);
        }
        sort(allk.begin(), allk.end());
        for (int j = 0; j + 1 < allk.size(); ++j) {
            out[i] = max(out[i], get(allk[j] + 1, allk[j + 1]));
        }
    }
    ll ans = 0;
    int m; cin >> m;
    while (m--) {
        int p; ll s; cin >> p >> s;
        //cout << in[p] << ' ' << out[p] << '\n';
        ans += max(in[p] + s, out[p]);
    }
    cout << ans << '\n';
}
