#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>

using namespace std;

typedef long long ll;

const ll inf = 4e18 + 1329;

const int logmaxn = 17;
const int maxn = 50031;

ll st [logmaxn][maxn];

void build(ll*& x, const int& n) {
    for (int i = 0; i < n; ++i) {
        st[0][i] = x[i];
    }
    for (int l = 1; l < logmaxn; ++l) {
        for (int i = 0; i + (1 << l) <= n; ++i) {
            st[l][i] = max(st[l - 1][i], st[l - 1][i + (1 << (l - 1))]);
        }
    }
}

ll get(int L, int R) {
    if (L >= R) return -inf;
    if (L + 1 == R) return st[0][L];
    int l = 0;
    while ((1 << (l + 1)) <= R - L) {
        l += 1;
    }
    return max(st[l][L], st[l][R - (1 << l)]);
}

int* a = new int [maxn];
ll* t = new ll [maxn];
ll* in = new ll [maxn];
ll* out = new ll [maxn];

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.tie(0)->sync_with_stdio(0);
    int n; cin >> n;
    for (int i = 1; i <= n; ++i) cin >> a[i];
    fill(t, t + n + 1, 0);
    for (int d = 1; d <= n; ++d) {
        for (int i = d; i <= n; i += d) {
            t[d] += a[i];
        }
    }
    build(t, n + 1);
    fill(in, in + n + 1, -inf);
    fill(out, out + n + 1, -inf);
    for (int i = 1; i <= n; ++i) {
        if (i == 3) {
            // flex
        }
        vector<int> b = {0}, e = {n + 1};
        for (int k = 1; k * k <= i; ++k) {
            if (i % k != 0) continue;
            in[i] = max(in[i], t[k]);
            in[i] = max(in[i], t[i / k]);
            b.push_back(k);
            e.push_back(i / k);
        }
        for (int j = 0; j + 1 < b.size(); ++j) {
            out[i] = max(out[i], get(b[j] + 1, b[j + 1]));
        }
        out[i] = max(out[i], get(b.back() + 1, e.back()));
        for (int j = (int) e.size() - 1; j - 1 >= 0; --j) {
            out[i] = max(out[i], get(e[j] + 1, e[j - 1]));
        }
    }
    ll ans = 0;
    int m; cin >> m;
    while (m--) {
        int p; ll s; cin >> p >> s;
        //cout << in[p] << ' ' << out[p] << '\n';
        ans += max(in[p] + s, out[p]);
    }
    cout << ans << '\n';
}
