#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

struct node {
    int val, add = 0;
    node() {}
    node(int val): val(val) {}
    node(const node& l, const node& r) {
        val = max(l.val, r.val);
    }
};

const int maxh = 100031;

node tree [4 * maxh];

void push(int i, int L, int R) {
    if (L + 1 < R) {
        tree[2 * i + 1].add += tree[i].add;
        tree[2 * i + 2].add += tree[i].add;
    }
    tree[i].val += tree[i].add;
    tree[i].add = 0;
}

void upd(int qL, int qR, int d, int i, int L, int R) {
    push(i, L, R);
    if (qR <= L || R <= qL) return;
    if (qL <= L && R <= qR) {
        tree[i].add += d;
        push(i, L, R);
        return;
    }
    int m = (L + R) / 2;
    upd(qL, qR, d, 2 * i + 1, L, m); push(2 * i + 1, L, m);
    upd(qL, qR, d, 2 * i + 2, m, R); push(2 * i + 2, m, R);
    tree[i] = node(tree[2 * i + 1], tree[2 * i + 2]);
}

int get(int qL, int qR, int i, int L, int R) {
    push(i, L, R);
    if (qR <= L || R <= qL) return 0;
    if (qL <= L && R <= qR) return tree[i].val;
    int m = (L + R) / 2;
    int g1 = get(qL, qR, 2 * i + 1, L, m);
    int g2 = get(qL, qR, 2 * i + 2, m, R);
    return max(g1, g2);
}

struct point {
    int x, y;
    point() {}
    point(int x, int y): x(x), y(y) {}
    bool operator< (const point& other) const {
        return make_pair(x, y) < make_pair(other.x, other.y);
    }
};

signed main() {
    int n; cin >> n;
    int w, h; cin >> w >> h;
    vector<point> ps;
    vector<int> ally;
    unordered_map<int, int> compy;
    for (int i = 0; i < n; ++i) {
        int x, y; cin >> x >> y;
        ps.emplace_back(x, y);
        ally.push_back(y);
        ally.push_back(y - h);
    }
    sort(ally.begin(), ally.end());
    ally.resize(unique(ally.begin(), ally.end()) - ally.begin());
    int t = 0;
    for (int y : ally) {
        compy[y] = t; t += 1;
    }
    sort(ps.begin(), ps.end());
    fill(tree, tree + 4 * maxh, 0);
    int ans = 0;
    int R = 0;
    for (int L = 0; L < n; ++L) {
        while (R < n && ps[R].x <= ps[L].x + w) {
            upd(compy[ps[R].y - h], compy[ps[R].y] + 1, 1, 0, 0, maxh + 1);
            R += 1;
        }
        ans = max(ans, get(0, maxh, 0, 0, 1));
        upd(compy[ps[L].y - h], compy[ps[L].y] + 1, -1, 0, 0, maxh + 1);
    }
    cout << ans << '\n';
}
