#include "biggest.h"
#include <algorithm>
#include <iostream>
#include <vector>
#include <numeric>

#include <unordered_map>
#include <bitset>


constexpr int GG = 20000;
constexpr int KK = 5005;

int n, k;
int data[100005];
char help[KK][KK];
int ind[100005];

class Hash {
public:
	uint64_t operator()(const std::pair<int, int> &val)const {
		return std::hash<uint64_t>()((val.first << 32) | val.second);
	}
};
std::unordered_map<std::pair<int, int>, bool, Hash> map;


bool cmp0(int i, int j) {
	return compare(i, j) == i;
}


bool cmp(int i, int j) {
	if (k > GG) {
		cmp0(i, j);
	}
	if (i == j) {
		return false;
	}
	if (i > j) {
		return !cmp(j, i);
	}
	if (map.find(std::pair<int, int>{ i, j }) != map.end()) {
		return map[std::pair<int, int>{ i, j }];
	}
	return map[std::pair<int, int>{ i, j }] = cmp0(i, j);
}

bool cmp2(int i, int j) {
	if (i > j) {
		return !cmp2(j, i);
	}
	if (help[ind[i]][ind[j]] == -1) {
		help[ind[i]][ind[j]] = cmp0(i, j);
	}
	return help[ind[i]][ind[j]];
}

std::vector<int> biggest(int n, int k) {
	::n = n;
	::k = k;
	if (k <= GG) {
		map.rehash(3 * (1 << 20));
	}
	std::iota(data, data + n, 1);

	if (k == 1) {
		return { *std::min_element(data, data + n, cmp) };
	} else if (k >= 10000) {
		std::vector<int> vec(n);
		std::iota(vec.begin(), vec.end(), 1);
		std::partial_sort(vec.begin(), vec.begin() + k, vec.end(), cmp);
		return std::vector(vec.begin(), vec.begin() + k);
	} else {
		std::nth_element(data, data + k - 1, data + n, cmp);
		if (k > KK) {
			std::sort(data, data + k - 1, cmp0);
		} else {
			std::fill(ind, ind + n + 1, -1);
			for (int i = 0; i < (k - 1); i++) {
				ind[data[i]] = i;
			}
			for (int i = 0; i < k - 1; i++) {
				for (int j = 0; j < k - 1; j++) {
					help[i][j] = -1;
				}
			}
			for (const auto &it : map) {
				if ((ind[it.first.first] != -1) && (ind[it.first.second] != -1)) {
					help[ind[it.first.first]][ind[it.first.second]] = it.second;
				}
			}
			std::sort(data, data + k - 1, cmp2);
		}
		return std::vector(data, data + k);
	}
	exit(1);
}