﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>

#include <immintrin.h>

#ifdef  EVAL
#define __lzcnt(val) __builtin_clz(val)
#endif //  EVAL


template<typename T>
struct ST {
private:
	T **data;
	int size, layerCnt;

public:

	ST(int n, const T *base) : size(n), layerCnt(32 - __lzcnt(n)), data(new T *[32 - __lzcnt(n)]) {
		for (int i = 0; i < layerCnt; i++) {
			data[i] = new T[size];
		}
		std::copy(base, base + n, data[0]);
		for (int k = 1; k < layerCnt; k++) {
			for (int i = 0; i < (n - (1 << k) + 1); i++) {
				data[k][i] = std::max(data[k - 1][i], data[k - 1][i + (1 << k - 1)]);
			}
		}
	}

	//[l, r)
	T get(int l, int r) {
		if (l == r) {
			return -1e18;
		}
		int lg = 31 - __lzcnt(r - l);
		return std::max(data[lg][l], data[lg][r - (1 << lg)]);
	}
};


int64_t sum[50005];
int n, input[50005], m;
std::vector<int> dv[50005], primes;

const std::vector<int> &div(int val) {
	if (dv[val].empty()) {
		for (int j = 1; (j * j) <= val; j++) {
			if ((val % j) == 0) {
				if ((j * j) == val) {
					dv[val].push_back(j);
				} else {
					dv[val].push_back(j);
					dv[val].push_back(val / j);
				}
			}
		}
		std::sort(dv[val].begin(), dv[val].end());
	}
	return dv[val];
}



int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);
	if constexpr (false) {
		std::cin >> n;
		for (int i = 0; i < n; i++) {
			input[i] = rand();
		}
		ST st(n, input);
		for (int i = 0; i < n; i++) {
			int max = 0;
			for (int j = i; j < n; j++) {
				max = std::max(max, input[j]);
				if (max != st.get(i, j + 1)) {
					st.get(i, j + 1);
					st.get(i, j + 1);
					st.get(i, j + 1);
					st.get(i, j + 1);
					st.get(i, j + 1);
					exit(1);
				}
			}
		}
	}


	std::cin >> n;
	for (int i = 1; i <= n; i++) {
		std::cin >> input[i];
	}

	for (int i = 1; i <= n; i++) {
		for (int j = i; j <= n; j += i) {
			sum[i] += input[j];
		}
	}
	ST st(n + 1, sum);
	int64_t ans = 0;

	std::cin >> m;
	for (int test = 0; test < m; test++) {
		int p;
		int64_t s;
		std::cin >> p >> s;

		int64_t max = -1e18;
		const auto &vec = div(p);
		
		max = std::max(max, st.get(1, vec.front()));
		for (int i = 1; i < vec.size(); i++) {
			max = std::max(max, st.get(vec[i - 1] + 1, vec[i]));
		}
		max = std::max(max, st.get(vec.back() + 1, n + 1));

		for (int i = 0; i < vec.size(); i++) {
			max = std::max(max, sum[vec[i]] + s);
		}
		std::cerr << "res: " << max << '\n';
		ans += max;
	}

	std::cerr << "ans: ";
	std::cout << ans << '\n';


	std::cout.flush();
	return 0;
}