﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <functional>


#define abs(x) abss(x)
template<typename T>
T abss(T val) {
	return (val >= 0) ? val : (-val);
}

void comp(std::vector<int *> &vec) {
	if (vec.empty()) {
		return;
	}
	std::sort(vec.begin(), vec.end(), [](int *a, int *b) {return (*a) < (*b); });
	int last = *vec[0];
	*vec[0] = 0;
	for (int i = 1; i < vec.size(); i++) {
		int r = *vec[i];
		*vec[i] = *vec[i - 1] + std::min(1, r - last);
		last = r;
	}
}


struct ST {
private:
	struct Data {
		int max, tag;

		Data(int val = 0) : max(val), tag(0) {
			;
		}
	};

	Data *data;
	int size;

	void upd(int i, int dlt) {
		data[i].max += dlt;
		data[i].tag += dlt;
	}

	void push(int i) {
		if ((i < size) && (data[i].tag != 0)) {
			upd(2 * i, data[i].tag);
			upd(2 * i + 1, data[i].tag);
			data[i].tag = 0;
		}
	}

	void merge(int i) {
		if (i < size) {
			data[i].max = std::max(data[2 * i].max, data[2 * i + 1].max);
			data[i].tag = 0;
		}
	}

	void update2(int i, int l, int r, int ql, int qr, int dlt) {
		if ((l >= qr) || (r <= ql)) {
			return;
		}
		if ((ql <= l) && (r <= qr)) {
			upd(i, dlt);
		} else {
			push(i);
			update2(2 * i, l, (l + r) / 2, ql, qr, dlt);
			update2(2 * i + 1, (l + r) / 2, r, ql, qr, dlt);
			merge(i);
		}
	}

public:

	ST() {

	}

	ST(int n) {
		for (size = 1; size < n; size *= 2) {
			;
		}
		data = new Data[size * 2];
	}

	//[l, r)
	void update(int l, int r, int dlt) {
		update2(1, 0, size, l, r, dlt);
	}

	int getMax() {
		return data[1].max;
	}
};



int n, w, h;
std::pair<int, std::pair<int, int>> queries[800005];



int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);

	std::cin >> n >> w >> h;
	std::vector<int *> vec;
	for (int i = 0; i < n; i++) {
		int x, y;
		std::cin >> x >> y;
		queries[2 * i] = { x, { y, y + h + 1 } };
		queries[2 * i + 1] = { -(x + w + 1), { y, y + h + 1 } };

		vec.push_back(&queries[2 * i].second.first);
		vec.push_back(&queries[2 * i].second.second);
		vec.push_back(&queries[2 * i + 1].second.first);
		vec.push_back(&queries[2 * i + 1].second.second);
	}
	comp(vec);

	std::sort(queries, queries + 2 * n, [](const auto &a, const auto &b) {
		int x = a.first, y = b.first;
		x = abs(x);
		y = abs(y);
		return x < y;
	});


	ST st(2 * n + 5);
	int ans = 0;
	for (int i = 0; i < 2 * n; i++) {
		st.update(queries[i].second.first, queries[i].second.second, (queries[i].first > 0) * 2 - 1);
		if ((i == (2 * n - 1)) || (abs(queries[i].first) != abs(queries[i + 1].first))) {
			ans = std::max(ans, st.getMax());
		}
	}

	std::cout << ans << '\n';


	std::cout.flush();
	return 0;
}