#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <set>
#include <map>
#include <math.h>
#include <queue>

using namespace std;

typedef long long ll;
const int INF = INT_MAX;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int n;
    cin >> n;

    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }

    int glob_max = -INF;

    vector<int> k(n);
    for (int i = 1; i <= n; i++)
    {
        for (int j = (i - 1); j < n; j += i)
        {
            k[i - 1] += a[j];
        }
        glob_max = max(glob_max, k[i - 1]);
    }

    vector <int> max_suff(n);
    max_suff[n - 1] = k[n - 1];
    for (int i = n - 2; i > -1; i--) {
        max_suff[i] = max(max_suff[i + 1], max_suff[i]);
    }

    int ans = 0;

    int m;
    cin >> m;
    while (m--)
    {
        int p, s;
        cin >> p >> s;

        int maxim = -1;

        int last_b;
        for (int b = 1; b * b <= p; b++) {
            if (p % b == 0) {
                maxim = max(maxim, k[b - 1] + s);
                maxim = max(maxim, k[p / b - 1] + s); 
            }
            else {
                maxim = max(maxim, k[b - 1]);
            }
            last_b = b;
        }
        maxim = max(maxim, max_suff[last_b + 1]);
        ans += maxim;
    }

    cout << ans << '\n';
}