#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <set>
#include <map>
#include <math.h>
#include <queue>

using namespace std;

typedef long long ll;
const ll INF = LONG_LONG_MAX;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    
    #ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
    #endif
    
    int n;
    cin >> n;
    
    vector <ll> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector <ll> k(n);

    for (int i = 0; i < n; i++) {
        if (i > (n + 1) / 2) {
            k[i] = a[i];
            continue;
        }
        for (int j = i; j < n; j+=i+1) {
            k[i] += a[j];
        }
    }

    vector <ll> max_suff(n);
    max_suff[n - 1] = a[n - 1];
    for (int i = n - 2; i > -1; i--) {
        max_suff[i] = max(max_suff[i + 1], k[i]);
    }

    int m;
    cin >> m;

    ll ans = 0; 

    while (m--) {
        ll p, s;
        cin >> p >> s;

        ll maxim = -INF;
        for (ll j = 0; j < p; j++) {
            if (p % (j + 1) == 0) {
                maxim = max(maxim, k[j] + s);
            }
            else {
                maxim = max(maxim, k[j]);
            }
        }
        if (p != n) {
            maxim = max(maxim, max_suff[p]);
        }

        ans += maxim;
    }

    cout << ans << '\n';
}