#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <set>
#include <map>
#include <math.h>
#include <queue>

using namespace std;

typedef long long ll;
const int INF = INT_MAX;

struct tri
{
    int first, second, third;

    tri() {}

    tri(int a, int b, int c)
    {
        first = a;
        second = b;
        third = c;
    }

    bool operator<(tri &other)
    {
        if (first != other.first)
        {
            return first < other.first;
        }
        if (second != other.second)
        {
            return second < other.second;
        }
        if (third != other.third)
        {
            return third < other.third;
        }
        return false;
    }

    void print()
    {
        cout << first << ' ' << second << ' ' << third << '\n';
    }
};

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int n, w, h;
    cin >> n >> w >> h;

    vector<tri> xarr;
    vector<tri> yarr;

    bool flag = false;

    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        if (x == w)
        {
            flag = true;
        }
        xarr.push_back(tri(max(0, x - w), 0, i));
        xarr.push_back(tri(x, 1, i));

        yarr.push_back(tri(max(0, y - h), 0, i));
        yarr.push_back(tri(y, 1, i));
    }

    if (!flag)
    {
        xarr.push_back(tri(0, 0, n));
        xarr.push_back(tri(w, 1, n));
    }

    sort(xarr.begin(), xarr.end());
    sort(yarr.begin(), yarr.end());

    // for (auto u : xarr)
    // {
    //     u.print();
    // }

    vector<bool> xp(n + 1, false);

    vector <int> xkek(n);
    int pts = 0;

    for (auto x : xarr) {
        if (x.second == 0) {
            pts++;
            xkek[x.third] = pts;
        }
        else {
            pts--;
        }
    }

    
    vector <int> ykek(n);
    pts = 0;

    for (auto y : yarr) {
        if (y.second == 0) {
            pts++;
            ykek[y.third] = pts;
        }
        else {
            pts--;
        }
    }

    int ans = -100;
    for (int i = 0; i < n; i++) {
        ans = max(ans, min(xkek[i], ykek[i]));
    }

    cout << ans << '\n';

    // for (auto x : xarr)
    // {
    //     pts = 0;
        
    //     if (x.second == 0)
    //     {
    //         xp[x.third] = true;
    //     }
    //     else
    //     {
    //         xp[x.third] = false;
    //     }

    //     for (auto y : yarr)
    //     {
    //         if (!xp[y.third])
    //         {
    //             continue;
    //         }
    //         if (y.second == 0)
    //         {
    //             pts++;
    //         }
    //         else
    //         {
    //             pts--;
    //         }
    //         ans = max(pts, ans);
    //     }
    // }
}