//
// Created by avevad on 11/21/20.
//

#include <vector>
#include <ctime>
#include <cstdlib>
#include <iostream>
#include "biggest.h"

using namespace std;

typedef long long ll;

inline ll randint(ll n) {
    return ((ll(rand()) * ll(RAND_MAX)) + ll(rand())) % n;
}

const ll N = 1000;
vector<pair<pair<ll, ll>, bool>> cache(N, {{-1, -1}, 0});

bool my_compare(ll x, ll y) {
    if (x == y) return 0;
    for (auto&[req, res] : cache) if (req.first == x && req.second == y) return res;
    //cout << x << " " << y << ": not in cache\n";
    ll res = (compare(x + 1, y + 1) - 1) == y;
    cache.pop_back();
    cache.insert(cache.begin(), {{x, y}, res});
    return res;
}

void bisect(vector<ll> &o, ll beg, ll end, ll k, vector<ll> &a) {
    if (k <= 0) return;
    if (beg + 1 == end) {
        a.push_back(o[beg]);
        return;
    }
    auto l = beg, r = end;
    ll x = o[l + randint(r - l)];
    while (l != r) {
        ll nr = r - 1;
        ll nl = l + 1;
        ll lc = my_compare(o[l], x);
        ll rc = my_compare(o[nr], x);
        if (!lc && rc) {
            swap(o[l], o[nr]);
            lc = 1;
            rc = 0;
        }
        if (lc) l = nl;
        if (!rc) r = nr;
    }
    ///////
    //vector<ll> kek(end - beg, 0);
    //for (ll i = 0; i < kek.size(); i++) kek[i] = my_compare(o[beg + i], x);
    ll m = l;
    bisect(o, m, end, min(end - m, k), a);
    bisect(o, beg, m, k - (end - m), a);
}

std::vector<int> biggest(int N, int K) {
    srand(time(0));
    ll n = N;
    ll k = K;
    vector<ll> r;
    vector<ll> o(n, 0);
    for (ll i = 0; i < n; i++) o[i] = i;
    bisect(o, 0, o.size(), k, r);
    vector<int> R;
    R.reserve(r.size());
    for (ll e : r) R.push_back(e + 1);
    return R;
}

