//

// Created by avevad on 11/21/20.

//



#include <vector>

#include <ctime>

#include <cstdlib>

#include <iostream>

#include "biggest.h"


using namespace std;


typedef long long ll;


inline ll randint(ll n) {

    return ((ll(rand()) * ll(RAND_MAX)) + ll(rand())) % n;

}


const ll N = 100;

vector<pair<pair<ll, ll>, bool>> cache(N, {{-1, -1}, 0});

bool my_compare(ll x, ll y) {
    if (x == y) return 0;
    for (auto&[req, res] : cache) if (req.first == x && req.second == y) return res;
    //cout << x << " " << y << ": not in cache\n";
    ll res = (compare(x + 1, y + 1) - 1) == y;
    cache.pop_back();
    cache.insert(cache.begin(), {{x, y}, res});
    return res;
}

void bisect(vector<ll> &o, ll beg, ll end, ll k, vector<ll> &a) {
    if (beg == end) return;
    if (k <= 0) return;
    if (beg + 1 == end) {
        a.push_back(o[beg]);
        return;
    }
    ll x = o[beg + randint(end - beg)];
    vector<ll> no(end - beg);
    ll l = 0, r = end - beg, px = -1;
    for (ll i = 0; i < end - beg; i++) {
        if (my_compare(o[beg + i], x)) no[l++] = o[beg + i];
        else no[--r] = o[beg + i];
        if (o[beg + i] == x) px = r;
    }
    ll m = r;
    swap(no[px], no[m]);
    for (ll i = 0; i < end - beg; i++) {
        o[beg + i] = no[i];
    }
    m += beg;
    //vector<ll> kek(end - beg, 0);
    //for (ll i = 0; i < end - beg; i++) kek[i] = my_compare(no[i], x);
    bisect(o, m + 1, end, min(k, end - m - 1), a);
    if (k >= end - m) a.push_back(x);
    bisect(o, beg, m, k - (end - m), a);
}


std::vector<int> biggest(int N, int K) {
    srand(time(0));
    ll n = N;
    ll k = K;
    vector<ll> o(n, 0);
    for (ll i = 0; i < n; i++) o[i] = i;
    sort(o.begin(), o.end(), [](ll a, ll b) -> bool { return my_compare(a, b); });
    vector<int> R;
    for (ll i = 0; i < k; i++) R.push_back(o[n - i - 1] + 1);
    return R;
}
