#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct P {
    ll x, y;

    P(ll x, ll y) : x(x), y(y) {}

    P() : P(0, 0) {}
};

ll p_add(vector<ll> &w, vector<ll> &w1, ll i) {
    ll r = !w[i] && w1[i];
    w[i] = 1;
    return r;
}

ll p_del(vector<ll> &w, vector<ll> &w1, ll i) {
    ll r = w[i] && w1[i];
    w[i] = 0;
    return r;
}

ll solve_light(ll n, ll w, ll h, vector<P> &p) {
    vector<ll> sx(n, 0), sy(n, 0);
    for (ll i = 0; i < n; i++) sx[i] = sy[i] = i;
    sort(sx.begin(), sx.end(), [&p](ll a, ll b) -> bool { return p[a].x < p[b].x; });
    sort(sy.begin(), sy.end(), [&p](ll a, ll b) -> bool { return p[a].y < p[b].y; });
    ll ans = 0, cnt = 0;
    vector<ll> wx(n, 0), wy(n, 0);
    ll t = 0, b = 0;
    while (b < n) {
        while (t < n && p[sy[t]].y - p[sy[b]].y <= h) cnt += p_add(wy, wx, sy[t++]);
        ll l = 0, r = 0;
        while (l < n) {
            while (r < n && p[sx[r]].x - p[sx[l]].x <= w) cnt += p_add(wx, wy, sx[r++]);
            ans = max(ans, cnt);
            cnt -= p_del(wx, wy, sx[l++]);
        }
        cnt -= p_del(wy, wx, sy[b++]);
    }
    return ans;
}

ll solve_fast(ll n, ll w, ll h, vector<P> &p) {
    ll mx = 0, my = 0;
    for (auto&[x, y] : p) {
        mx = max(x, mx);
        my = max(y, my);
    }
    vector<vector<ll>> a(mx + 1, vector<ll>(my + 1, 0));
    for (auto&[x, y] : p) a[x][y]++;
    vector<vector<ll>> d(mx + 1, vector<ll>(my + 1, 0));
    for (ll x = 1; x <= mx; x++) {
        for (ll y = 1; y <= my; y++) {
            d[x][y] = d[x - 1][y] + d[x][y - 1] - d[x - 1][y - 1] + a[x][y];
        }
    }
    ll ans = 0;
    for (auto&[x, y] : p) {
        ll x2 = x;
        ll y2 = y;
        ll x1 = max(0ll, x - w - 1);
        ll y1 = max(0ll, y - h - 1);
        ans = max(ans, d[x2][y2] - d[x1][y2] - d[x2][y1] + d[x1][y1]);
    }
    return ans;
}

int main() {
    ll n, w, h;
    cin >> n >> w >> h;
    vector<P> p(n, P());
    for (auto&[x, y] : p) cin >> x >> y;
    if (n > 1000) cout << solve_fast(n, w, h, p);
    else cout << solve_light(n, w, h, p);
}
