#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;
const int MAXS = 1e3 + 10;
const int MAXN = 1e5 + 10;

void fast_io()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

struct point
{
    int x, y;
} p[MAXN];

bool cmpx(point p1, point p2)
{
    return p1.x < p2.x;
}

bool cmpy(point p1, point p2)
{
    return p1.y < p2.y;
}

int n, h, w, a[MAXS][MAXS], dp[MAXS][MAXS];
vector < point > v[MAXN * 4];

void build_tree(int root, int left, int right)
{
    if (left == right)
    {
        v[root].push_back(p[left]);
        return;
    }

    int mid = (left + right) / 2;
    build_tree(root * 2, left, mid);
    build_tree(root * 2 + 1, mid + 1, right);

    v[root] = v[root * 2];
    int sz = v[root * 2 + 1].size();
    for (int i = 0; i < sz; i ++)
        v[root].push_back(v[root * 2 + 1][i]);
    sort(v[root].begin(), v[root].end(), cmpy);
}

int find_sum(int root, int left, int right, int qleft, int qright, int &dl, int &ul)
{

    if (left == qleft && right == qright)
    {
        /*cout << root << " " << left << " " << right << " " << qleft << " " << qright << " " << dl << " " << ul << endl;
        cout << "---------------" << endl;
        for (int i = 0; i < v[root].size(); i ++)
            cout << v[root][i].x << " " << v[root][i].y << endl;*/

        int left = 0, right = v[root].size() - 1;
        while(left <= right)
        {
            int mid = (left + right) / 2;
            if (v[root][mid].y < dl)
                left = mid + 1;
            else
                right = mid - 1;
        }

        if (left == v[root].size())
            return 0;

        int k1 = left;

        left = 0;
        right = v[root].size() - 1;
        while(left <= right)
        {
            int mid = (left + right) / 2;
            if (v[root][mid].y <= ul)
                left = mid + 1;
            else
                right = mid - 1;
        }

        if (right < 0)
            return 0;

        int k2 = right;
        return k2 - k1 + 1;
    }

    int mid = (left + right) / 2;

    if (qright <= mid)
        return find_sum(root * 2, left, mid, qleft, qright, dl, ul);
    if (qleft > mid)
        return find_sum(root * 2 + 1, mid + 1, right, qleft, qright, dl, ul);

    return find_sum(root * 2, left, mid, qleft, mid, dl, ul) +
           find_sum(root * 2 + 1, mid + 1, right, mid + 1, qright, dl, ul);
}
void solve()
{
    cin >> n >> h >> w;
    if (n <= 1e2)
    {
        for (int i = 1; i <= n; i ++)
        {
            int x, y;
            cin >> x >> y;
            a[x][y] ++;
        }
        h ++;
        w ++;

        int ans = 0;
        for (int i = 1; i < MAXS; i ++)
            for (int j = 1; j < MAXS; j ++)
            {
                dp[i][j] = dp[i][j - 1] + dp[i - 1][j] - dp[i - 1][j - 1] + a[i][j];
                if (i >= h && j >= w)
                {
                    int s = dp[i][j] - dp[i - h][j] - dp[i][j - w] + dp[i - h][j - w];
                    if (s > ans)
                        ans = s;
                }
            }

        cout << ans << endl;
    }
    else
    {
        if (n <= 1e3)
        {
            for (int i = 1; i <= n; i ++)
                cin >> p[i].x >> p[i].y;

            sort(p + 1, p + n + 1, cmpx);

            /**cout << "----------------" << endl;
            for (int i = 1; i <= n; i ++)
                cout << p[i].x << " " << p[i].y << endl;
            cout << "----------------" << endl;*/
            build_tree(1, 1, n);

            int ans = 0;
            for (int i = 1; i <= n; i ++)
                for (int j = 1; j <= n; j ++)
                {
                    point kk;
                    kk.x = p[i].x;
                    kk.y = p[j].y;

                    if (kk.x >= h && kk.y >= w)
                    {
                        int nh = kk.x - h;
                        int ny = kk.y - w;

                        int left = 1, right = n;
                        while(left <= right)
                        {
                            int mid = (left + right) /2;
                            if (p[mid].x < nh)
                                left = mid + 1;
                            else
                                right = mid - 1;
                        }

                        int lb = left;

                        left = 1;
                        right = n;
                        while(left <= right)
                        {
                            int mid = (left + right) / 2;
                            if (p[mid].x <= kk.x)
                                left = mid + 1;
                            else
                                right = mid - 1;
                        }

                        int rb = right;


                        //cout << i << " " << lb << " " << rb << endl;
                        int sum = find_sum(1, 1, n, lb, rb, ny, kk.y);
                        if (sum > ans)
                            ans = sum;

                    }

                }

                cout << ans << endl;
        }
        else
        {
            for (int i = 1; i <= n; i ++)
                cin >> p[i].x >> p[i].y;

            sort(p + 1, p + n + 1, cmpx);

            /**cout << "----------------" << endl;
            for (int i = 1; i <= n; i ++)
                cout << p[i].x << " " << p[i].y << endl;
            cout << "----------------" << endl;*/
            build_tree(1, 1, n);

            int ans = 0;
            for (int i = 1; i <= n; i ++)
            {
                if (p[i].x >= h && p[i].y >= w)
                {
                    int nh = p[i].x - h;
                    int ny = p[i].y - w;

                    int left = 1, right = n;
                    while(left <= right)
                    {
                        int mid = (left + right) /2;
                        if (p[mid].x < nh)
                            left = mid + 1;
                        else
                            right = mid - 1;
                    }

                    int lb = left;

                    left = 1;
                    right = n;
                    while(left <= right)
                    {
                        int mid = (left + right) / 2;
                        if (p[mid].x <= p[i].x)
                            left = mid + 1;
                        else
                            right = mid - 1;
                    }

                    int rb = right;


                    //cout << i << " " << lb << " " << rb << endl;
                    int sum = find_sum(1, 1, n, lb, rb, ny, p[i].y);
                    if (sum > ans)
                        ans = sum;

                }
            }
            cout << ans << endl;
        }
    }
}

int main()
{
    solve();
    return 0;
}
