#include <iostream>
#include <vector>
#include <cmath>
using namespace std;
typedef long long ll;
const ll maxn = 5e4+10, maxm = 5e5+10;
vector < ll > d[maxn];
ll a[maxn];
ll sums[maxn];
void find_div(ll x) {
    ll sq = sqrt(x);
    if (sq*sq < x) ++sq;
    for (ll i = 1 ; i <= sq && i <= x/i ; ++i) {
        if (x % i == 0) {
            //cerr << x << ": " << a[x] << ' ' << i << ' ' << x/i << ' ' << sq << '\n';
            d[x].push_back(i);
            sums[i] += a[x];
            if (i != x/i) {
                d[x].push_back(x/i);
                sums[x/i] += a[x];
            }
            //cerr << "sums[" << i << "]: " << sums[i] << '\n';
            //cerr << "sums[" << x/i << "]: " << sums[x/i] << '\n';
        }
    }
}
ll tree[4*maxn];
ll initialize(int l, int r, int node) {
    if (l == r) return tree[node] = sums[l];
    return tree[node] = max(initialize(l, (l+r)/2, node*2), initialize((l+r)/2+1, r, node*2+1));
}
int upd_l, upd_r;
ll update(int l, int r, int node) {
    if (r < upd_l || l > upd_r) return tree[node];
    if (l == r) return tree[node] = sums[l];
    return tree[node] = max(update(l, (l+r)/2, node*2), update((l+r)/2+1, r, node*2+1));
}
ll answer(int l, int r, int node) {
    if (r < upd_l || l > upd_r) return 0;
    if (l == r) return tree[node];
    return max(answer(l, (l+r)/2, node*2), answer((l+r)/2+1, r, node*2+1));
}
ll n, m, p, s, ans, len = 1, begmax, currmax;
/*void print() {
    cout << "sums:\n";
    for (int i = 1 ; i <= n ; ++i)m
        cout << i << " -> " << sums[i] << '\n';
    cout << '\n';
}*/
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    for (ll i = 1 ; i <= n ; ++i)
        cin >> a[i];
    for (ll i = 1 ; i <= n ; ++i)
        find_div(i);
    //print();
    while (len < n) len *= 2;
    initialize(0, len-1, 1);
    begmax = tree[1];
    cin >> m;
    for (ll i = 1 ; i <= m ; ++i) {
        cin >> p >> s;
        if (s < 0) {
            //cout << "d[p]: ";
            for (ll x : d[p]) {
                //cout << x << ' ';
                sums[x] += s;
                upd_l = upd_r = x;
                update(0, len-1, 1);
            }
            //cout << '\n';
            //cout << "add: " << tree[1] << '\n';
            //print();
            ans += tree[1];
            for (ll x : d[p]) {
                sums[x] -= s;
                upd_l = upd_r = x;
                update(0, len-1, 1);
            }
        } else {
            currmax = begmax;
            for (ll x : d[p]) {
                currmax = max(currmax, sums[x] + s);
            }
            ans += currmax;
        }
    }
    cout << ans << '\n';
    return 0;
}
