#include <iostream>
#include <algorithm>
#include <unordered_map>
using namespace std;
#define endl '\n'
struct Point{
    int x, y;
};
const int MAXN=1e5+10;
const int MAXT=1e3+10;
const int MAXX=1e8+10;
Point p[MAXN];
unordered_map <int,int> mx, my;
int x[MAXN], y[MAXN], maxx;
int t[MAXT][MAXT], pr[MAXT][MAXT];
int tree[4*MAXN];
int n;
bool cmp(Point a, Point b) {
    return a.y>b.y;
}
void prefix() {
    for (int i=1;i<=n+1;i++) {
        for (int j=1;j<=n+1;j++) {
            pr[i][j]=t[i][j]+pr[i-1][j]+pr[i][j-1]-pr[i-1][j-1];
        }
    }
}
int bsx(int curx, int indx) {
    int l, r, mid;
    l=0; r=n-1;
    while (l<=r) {
        mid=(l+r)/2;
        if (indx==-1) {
            if (x[mid]>=curx) r=mid-1;
            else l=mid+1;
        } else {
            if (x[mid]<=curx) l=mid+1;
            else r=mid-1;
        }
    }
    if (indx==-1) return mx[x[l]];
    else return mx[x[r]];
}
int bsy(int cury, int indy) {
    int l, r, mid;
    l=0; r=n-1;
    while (l<=r) {
        mid=(l+r)/2;
        if (indy==-1) {
            if (y[mid]>=cury) r=mid-1;
            else l=mid+1;
        } else {
            if (y[mid]<=cury) l=mid+1;
            else r=mid-1;
        }
    }
    if (indy==-1) return my[y[l]];
    else return my[y[r]];
}
Point find_point(int x, int y, int indx, int indy) {
    Point ans;
    ans.x=bsx(x,indx);
    ans.y=bsy(y,indy);
    return ans;
}
int find_table(int x1, int y1, int x2, int y2) {
    x1=max(x1-1,0);
    y1=max(y1-1,0);
    return pr[x2][y2]-pr[x2][y1]-pr[x1][y2]+pr[x1][y1];
}
int rect(int x, int y, int w, int h) {
    int ans=0;
    Point cur;
    cur=find_point(x-w,y-h,-1,-1);
    ans=max(ans,find_table(cur.x,cur.y,mx[x],my[y]));
    cur=find_point(x-w,y+h,-1,1);
    ans=max(ans,find_table(cur.x,my[y],mx[x],cur.y));
    cur=find_point(x+w,y-h,1,-1);
    ans=max(ans,find_table(mx[x],cur.y,cur.x,my[y]));
    cur=find_point(x+w,y+h,1,1);
    ans=max(ans,find_table(mx[x],my[y],cur.x,cur.y));
    return ans;
}
void update(int node, int l, int r, int qind, int ch) {
    if (qind>r || qind<l) return;
    if (l==r) {
        tree[node]+=ch;
        return;
    }
    int mid=(l+r)/2;
    update(node*2,l,mid,qind,ch);
    update(node*2+1,mid+1,r,qind,ch);
    tree[node]=tree[node*2]+tree[node*2+1];
}
int query(int node, int l, int r, int ql, int qr) {
    if (ql>r || qr<l) return 0;
    if (l>=ql && r<=qr) return tree[node];
    int mid=(l+r)/2;
    return query(node*2,l,mid,ql,qr)+query(node*2+1,mid+1,r,ql,qr);
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int w, h;
    bool ok=true;
    cin >> n >> w >> h;
    for (int i=0;i<n;i++) {
        cin >> p[i].x >> p[i].y;
        x[i]=p[i].x;
        y[i]=p[i].y;
        maxx=max(maxx,x[i]);
    }
    sort(x,x+n);
    sort(y,y+n);
    int br1, br2;
    br1=br2=1;
    for (int i=0;i<n;i++) {
        if (i>0) {
            if (x[i]!=x[i-1]) br1++;
            if (y[i]!=y[i-1]) br2++;
        }
        mx[x[i]]=br1;
        my[y[i]]=br2;
    }
    if (n<=1000) {
        for (int i=0;i<n;i++) t[mx[p[i].x]][my[p[i].y]]++;
        prefix();
        int ans=0;
        for (int i=0;i<n;i++) {
            for (int j=0;j<n;j++) {
                ans=max(ans,rect(p[i].x,p[j].y,w,h));
            }
        }
        cout << ans << endl;
        return 0;
    }
    sort(p,p+n,cmp);
    int y1, gr, ans=0;
    br1=0;
    for (int i=0;i<n;i++) {
        y1=p[i].y;
        gr=i;
        while (i<n && p[i].y==y1) i++;
        i--;
        ///cout << gr << ' ' << i << endl;
        y1=p[i].y-h;
        while (br1<n && p[br1].y>=y1) {
            ///cout << p[br1].x << ' ' << p[br1].y << endl;
            update(1,0,maxx,p[br1].x,1);
            br1++;
        }
        ///cout << endl;
        for (int j=gr;j<=i;j++) {
            if (p[j].x>=w) ans=max(ans,query(1,0,maxx,p[j].x-w,p[j].x));
        }
        for (int j=gr;j<=i;j++) update(1,0,maxx,p[j].x,-1);
    }
    cout << ans << endl;
    return 0;
}
/**
6 2 3
1 1
3 1
2 2
3 3
5 3
3 5

10 8 8
8 9
20 14
3 9
7 8
3 4
7 8
10 19
6 11
5 10
8 2
**/
