#include <iostream>
#include <vector>
#include <set>
#include <unordered_map>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 100005
#define umap unordered_map
int br, w, h;
vector<pair<int, int> > input;
vector<int> arr[MAXN];
umap<int, int> encode, encode2;
int decode[MAXN], decode2[MAXN];
set<int> com, com2;
int tree[4 * MAXN], lazy[4 * MAXN];
void fix(int idx)
{
    tree[idx] += lazy[idx];
    lazy[2 * idx] += lazy[idx];
    lazy[2 * idx + 1] += lazy[idx];
    lazy[idx] = 0;
}
void update(int idx, int from, int to, int left, int right, int value)
{
    //cout << "up " << idx << ' ' << from << ' ' << to << ' ' << left << ' ' << right << ' ' << value << endl;
    fix(idx);
    if(from > to) return;
    if(right < decode2[from] || left > decode2[to]) return;
    if(decode2[from] >= left && decode2[to] <= right){
            //cout << "interval in\n";
        lazy[idx] += value; return;
    }
    int mid = (from + to) / 2;
    update(2 * idx, from, mid, left, right, value);
    update(2 * idx + 1, mid + 1, to, left, right, value);
    fix(2 * idx); fix(2 * idx + 1);
    //cout << "returning to" << idx << ' ' << from << ' ' << to << ' ' << left << ' ' << right << ' ' << value << endl;
    //cout << "children " << tree[2 * idx] << ' ' << tree[2 * idx + 1] << endl;
    tree[idx] = max(tree[2 * idx], tree[2 * idx + 1]);
}
signed main()
{
    cin.tie(0); ios::sync_with_stdio(false);
    cin >> br >> w >> h;
    for(int i = 0; i < br; ++i){
        int x, y; cin >> x >> y;
        com.insert(x);
        com2.insert(y);
        input.push_back({x, y});
    }
    int cnt = 1;
    for(int i : com){
        encode[i] = cnt; decode[cnt] = i;
        ++cnt;
    }
    cnt = 1;
    for(int i : com2){
        encode2[i] = cnt; decode2[cnt] = i;
        ++cnt;
    }
    for(pair<int, int> p : input){
        arr[encode[p.first]].push_back(p.second);
    }
    int l = 1, r = 1;
    int global = 0;
    for(; l <= com.size(); ++l){
        //cout << "STARTING " << l << endl;
        for(; r <= com.size();){
            if(decode[r] > decode[l] + h){
                break;
            }
            //cout << "ADDING " << r << endl;
            for(int i : arr[r]){
                int f = i - w;
                if(f <= decode2[1]) f = decode2[1];
                //cout << "UPDATING FROM " << f << ' ' << i << endl;
                update(1, 1, com2.size(), f, i, 1);
            }
            ++r;
        }
        //cout << "ENDING EXPANSION\n";
        //cout << "MAXIMUM IS: " << tree[1] << endl;
        global = max(global, tree[1]);
        if(r == com.size() + 1) break;
        //cout << "REMOVING: " << l << endl;
        for(int i : arr[l]){
            int f = i - w;
            if(f <= decode2[1]) f = decode2[1];
            //cout << "REMOVE UPDATE FROM " << f << ' ' << i << endl;
            update(1, 1, com2.size(), f, i, -1);
        }
    }
    //cout << "END\n";
    cout << global << endl;
    return 0;
}

