#include "biggest.h"
#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 100000;

int tree[4 * MAXN + 5];
vector<int> G[MAXN + 5];

int compare(int x, int y);

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = l;
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v] = compare(tree[2 * v], tree[2 * v + 1]);
    if (tree[v] == tree[2 * v]) G[tree[v]].push_back(tree[2 * v + 1]);
    else G[tree[v]].push_back(tree[2 * v + 1]);
}

vector<int> biggest(int N, int K)
{
    if (K <= 2)
    {
        build(1, 1, N);

        vector<int> v0;
        v0.push_back(tree[1]);
        if (K == 2)
        {
            int mx = G[tree[1]][0];
            for (int i = 1; i < G[tree[1]].size(); ++ i)
            {
                if (compare(mx, G[tree[1]][i]) != mx) mx = G[tree[1]][i];
            }
            v0.push_back(mx);
        }
        return v0;
    }

    vector<int> v;
    v.push_back(1);
    int sz = 1;
    for (int i = 2; i <= N; ++ i)
    {
        if (sz >= K)
        {
            if (compare(v[sz - K], i) != i) continue;
        }
        int l = (sz >= K ? sz - K : -1), r = sz, mid;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (compare(i, v[mid]) == i) l = mid;
            else r = mid;
        }
        v.insert(v.begin() + (l + 1), i);
        sz++;
    }

    vector<int> v0;
    for (int i = sz - 1; i >= sz - K; -- i)
    {
        v0.push_back(v[i]);
    }

    return v0;
}
