#include <iostream>
#include <vector>
#include <deque>
#include "biggest.h"

struct Node {
	Node(int v) {
		value = v;
	}
	int value;
	int index;
	std::vector<Node*> neighbours;
	std::vector<Node*> previous;
};

struct Graph {
	Graph(int n) {
		for (int i = 0; i < n; i++) {
			nodes.push_back(new Node(i + 1));
		}
	}
	void add_path(int first, int second) {
		first--;
		second--;
		nodes[first]->neighbours.push_back(nodes[second]);
		nodes[second]->previous.push_back(nodes[first]);
	}
	bool find_path(int first, int last) {
		first--;
		last--;
		std::deque<Node*> queue {nodes[first]};
		while (queue.size()) {
			Node* current = queue.front();
			if (current == nodes[last]) {
				return true;
			}
			queue.pop_front();
			for (auto node : current->neighbours) {
				queue.push_back(node);
			}
		}
		return false;
	}
	std::vector<Node*> nodes;
};

std::vector<int> biggest(int n, int k)
{
	std::vector<int> r(k);
	
	Graph g(n);
	for (int i = 0; i < n - 2; i++) {
		g.nodes[i]->index = i;
		if (compare(i, i + 1) == i) {
			g.add_path(i, i + 1);
		}
		else {
			g.add_path(i + 1, i);
		}
	}

	Node* node = g.nodes[0];
	while (node->previous.size()) {
		node = node->previous[0];
	}
	r.push_back(node->index);

	for (int i = 1; i < k; i++) {
		std::vector<Node*> c {node->neighbours};
		while (c.size() > 1) {
			if (compare(c[0]->index, c[1]->index == c[0]->index)) {
				c.erase(c.begin() + 1);
			}
			else {
				c.erase(c.begin() + 2);
			}
		}
		r.push_back(c[0]->index);
	}
	return r;
}